
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit2WebExtension.Objects.DOMHTMLInputElement
    ( 

-- * Exported types
    DOMHTMLInputElement(..)                 ,
    DOMHTMLInputElementK                    ,
    toDOMHTMLInputElement                   ,
    noDOMHTMLInputElement                   ,


 -- * Methods
-- ** dOMHTMLInputElementGetAccept
    dOMHTMLInputElementGetAccept            ,


-- ** dOMHTMLInputElementGetAlign
    dOMHTMLInputElementGetAlign             ,


-- ** dOMHTMLInputElementGetAlt
    dOMHTMLInputElementGetAlt               ,


-- ** dOMHTMLInputElementGetAutofocus
    dOMHTMLInputElementGetAutofocus         ,


-- ** dOMHTMLInputElementGetCapture
    dOMHTMLInputElementGetCapture           ,


-- ** dOMHTMLInputElementGetChecked
    dOMHTMLInputElementGetChecked           ,


-- ** dOMHTMLInputElementGetDefaultChecked
    dOMHTMLInputElementGetDefaultChecked    ,


-- ** dOMHTMLInputElementGetDefaultValue
    dOMHTMLInputElementGetDefaultValue      ,


-- ** dOMHTMLInputElementGetDisabled
    dOMHTMLInputElementGetDisabled          ,


-- ** dOMHTMLInputElementGetFiles
    dOMHTMLInputElementGetFiles             ,


-- ** dOMHTMLInputElementGetForm
    dOMHTMLInputElementGetForm              ,


-- ** dOMHTMLInputElementGetHeight
    dOMHTMLInputElementGetHeight            ,


-- ** dOMHTMLInputElementGetIndeterminate
    dOMHTMLInputElementGetIndeterminate     ,


-- ** dOMHTMLInputElementGetInputType
    dOMHTMLInputElementGetInputType         ,


-- ** dOMHTMLInputElementGetMaxLength
    dOMHTMLInputElementGetMaxLength         ,


-- ** dOMHTMLInputElementGetMultiple
    dOMHTMLInputElementGetMultiple          ,


-- ** dOMHTMLInputElementGetName
    dOMHTMLInputElementGetName              ,


-- ** dOMHTMLInputElementGetSize
    dOMHTMLInputElementGetSize              ,


-- ** dOMHTMLInputElementGetSrc
    dOMHTMLInputElementGetSrc               ,


-- ** dOMHTMLInputElementGetUseMap
    dOMHTMLInputElementGetUseMap            ,


-- ** dOMHTMLInputElementGetValue
    dOMHTMLInputElementGetValue             ,


-- ** dOMHTMLInputElementGetWidth
    dOMHTMLInputElementGetWidth             ,


-- ** dOMHTMLInputElementGetWillValidate
    dOMHTMLInputElementGetWillValidate      ,


-- ** dOMHTMLInputElementIsEdited
    dOMHTMLInputElementIsEdited             ,


-- ** dOMHTMLInputElementSelect
    dOMHTMLInputElementSelect               ,


-- ** dOMHTMLInputElementSetAccept
    dOMHTMLInputElementSetAccept            ,


-- ** dOMHTMLInputElementSetAlign
    dOMHTMLInputElementSetAlign             ,


-- ** dOMHTMLInputElementSetAlt
    dOMHTMLInputElementSetAlt               ,


-- ** dOMHTMLInputElementSetAutofocus
    dOMHTMLInputElementSetAutofocus         ,


-- ** dOMHTMLInputElementSetChecked
    dOMHTMLInputElementSetChecked           ,


-- ** dOMHTMLInputElementSetDefaultValue
    dOMHTMLInputElementSetDefaultValue      ,


-- ** dOMHTMLInputElementSetDisabled
    dOMHTMLInputElementSetDisabled          ,


-- ** dOMHTMLInputElementSetFiles
    dOMHTMLInputElementSetFiles             ,


-- ** dOMHTMLInputElementSetHeight
    dOMHTMLInputElementSetHeight            ,


-- ** dOMHTMLInputElementSetIndeterminate
    dOMHTMLInputElementSetIndeterminate     ,


-- ** dOMHTMLInputElementSetInputType
    dOMHTMLInputElementSetInputType         ,


-- ** dOMHTMLInputElementSetMaxLength
    dOMHTMLInputElementSetMaxLength         ,


-- ** dOMHTMLInputElementSetMultiple
    dOMHTMLInputElementSetMultiple          ,


-- ** dOMHTMLInputElementSetName
    dOMHTMLInputElementSetName              ,


-- ** dOMHTMLInputElementSetReadOnly
    dOMHTMLInputElementSetReadOnly          ,


-- ** dOMHTMLInputElementSetSize
    dOMHTMLInputElementSetSize              ,


-- ** dOMHTMLInputElementSetSrc
    dOMHTMLInputElementSetSrc               ,


-- ** dOMHTMLInputElementSetUseMap
    dOMHTMLInputElementSetUseMap            ,


-- ** dOMHTMLInputElementSetValue
    dOMHTMLInputElementSetValue             ,


-- ** dOMHTMLInputElementSetWidth
    dOMHTMLInputElementSetWidth             ,




 -- * Properties
-- ** Accept
    DOMHTMLInputElementAcceptPropertyInfo   ,
    constructDOMHTMLInputElementAccept      ,
    getDOMHTMLInputElementAccept            ,
    setDOMHTMLInputElementAccept            ,


-- ** Align
    DOMHTMLInputElementAlignPropertyInfo    ,
    constructDOMHTMLInputElementAlign       ,
    getDOMHTMLInputElementAlign             ,
    setDOMHTMLInputElementAlign             ,


-- ** Alt
    DOMHTMLInputElementAltPropertyInfo      ,
    constructDOMHTMLInputElementAlt         ,
    getDOMHTMLInputElementAlt               ,
    setDOMHTMLInputElementAlt               ,


-- ** Autocapitalize
    DOMHTMLInputElementAutocapitalizePropertyInfo,
    constructDOMHTMLInputElementAutocapitalize,
    getDOMHTMLInputElementAutocapitalize    ,
    setDOMHTMLInputElementAutocapitalize    ,


-- ** Autocomplete
    DOMHTMLInputElementAutocompletePropertyInfo,
    constructDOMHTMLInputElementAutocomplete,
    getDOMHTMLInputElementAutocomplete      ,
    setDOMHTMLInputElementAutocomplete      ,


-- ** Autocorrect
    DOMHTMLInputElementAutocorrectPropertyInfo,
    constructDOMHTMLInputElementAutocorrect ,
    getDOMHTMLInputElementAutocorrect       ,
    setDOMHTMLInputElementAutocorrect       ,


-- ** Autofocus
    DOMHTMLInputElementAutofocusPropertyInfo,
    constructDOMHTMLInputElementAutofocus   ,
    getDOMHTMLInputElementAutofocus         ,
    setDOMHTMLInputElementAutofocus         ,


-- ** Capture
    DOMHTMLInputElementCapturePropertyInfo  ,
    constructDOMHTMLInputElementCapture     ,
    getDOMHTMLInputElementCapture           ,
    setDOMHTMLInputElementCapture           ,


-- ** Checked
    DOMHTMLInputElementCheckedPropertyInfo  ,
    constructDOMHTMLInputElementChecked     ,
    getDOMHTMLInputElementChecked           ,
    setDOMHTMLInputElementChecked           ,


-- ** DefaultChecked
    DOMHTMLInputElementDefaultCheckedPropertyInfo,
    constructDOMHTMLInputElementDefaultChecked,
    getDOMHTMLInputElementDefaultChecked    ,
    setDOMHTMLInputElementDefaultChecked    ,


-- ** DefaultValue
    DOMHTMLInputElementDefaultValuePropertyInfo,
    constructDOMHTMLInputElementDefaultValue,
    getDOMHTMLInputElementDefaultValue      ,
    setDOMHTMLInputElementDefaultValue      ,


-- ** DirName
    DOMHTMLInputElementDirNamePropertyInfo  ,
    constructDOMHTMLInputElementDirName     ,
    getDOMHTMLInputElementDirName           ,
    setDOMHTMLInputElementDirName           ,


-- ** Disabled
    DOMHTMLInputElementDisabledPropertyInfo ,
    constructDOMHTMLInputElementDisabled    ,
    getDOMHTMLInputElementDisabled          ,
    setDOMHTMLInputElementDisabled          ,


-- ** Files
    DOMHTMLInputElementFilesPropertyInfo    ,
    getDOMHTMLInputElementFiles             ,


-- ** Form
    DOMHTMLInputElementFormPropertyInfo     ,
    getDOMHTMLInputElementForm              ,


-- ** FormAction
    DOMHTMLInputElementFormActionPropertyInfo,
    constructDOMHTMLInputElementFormAction  ,
    getDOMHTMLInputElementFormAction        ,
    setDOMHTMLInputElementFormAction        ,


-- ** FormEnctype
    DOMHTMLInputElementFormEnctypePropertyInfo,
    constructDOMHTMLInputElementFormEnctype ,
    getDOMHTMLInputElementFormEnctype       ,
    setDOMHTMLInputElementFormEnctype       ,


-- ** FormMethod
    DOMHTMLInputElementFormMethodPropertyInfo,
    constructDOMHTMLInputElementFormMethod  ,
    getDOMHTMLInputElementFormMethod        ,
    setDOMHTMLInputElementFormMethod        ,


-- ** FormNoValidate
    DOMHTMLInputElementFormNoValidatePropertyInfo,
    constructDOMHTMLInputElementFormNoValidate,
    getDOMHTMLInputElementFormNoValidate    ,
    setDOMHTMLInputElementFormNoValidate    ,


-- ** FormTarget
    DOMHTMLInputElementFormTargetPropertyInfo,
    constructDOMHTMLInputElementFormTarget  ,
    getDOMHTMLInputElementFormTarget        ,
    setDOMHTMLInputElementFormTarget        ,


-- ** Height
    DOMHTMLInputElementHeightPropertyInfo   ,
    constructDOMHTMLInputElementHeight      ,
    getDOMHTMLInputElementHeight            ,
    setDOMHTMLInputElementHeight            ,


-- ** Incremental
    DOMHTMLInputElementIncrementalPropertyInfo,
    constructDOMHTMLInputElementIncremental ,
    getDOMHTMLInputElementIncremental       ,
    setDOMHTMLInputElementIncremental       ,


-- ** Indeterminate
    DOMHTMLInputElementIndeterminatePropertyInfo,
    constructDOMHTMLInputElementIndeterminate,
    getDOMHTMLInputElementIndeterminate     ,
    setDOMHTMLInputElementIndeterminate     ,


-- ** Labels
    DOMHTMLInputElementLabelsPropertyInfo   ,
    getDOMHTMLInputElementLabels            ,


-- ** List
    DOMHTMLInputElementListPropertyInfo     ,
    getDOMHTMLInputElementList              ,


-- ** Max
    DOMHTMLInputElementMaxPropertyInfo      ,
    constructDOMHTMLInputElementMax         ,
    getDOMHTMLInputElementMax               ,
    setDOMHTMLInputElementMax               ,


-- ** MaxLength
    DOMHTMLInputElementMaxLengthPropertyInfo,
    constructDOMHTMLInputElementMaxLength   ,
    getDOMHTMLInputElementMaxLength         ,
    setDOMHTMLInputElementMaxLength         ,


-- ** Min
    DOMHTMLInputElementMinPropertyInfo      ,
    constructDOMHTMLInputElementMin         ,
    getDOMHTMLInputElementMin               ,
    setDOMHTMLInputElementMin               ,


-- ** Multiple
    DOMHTMLInputElementMultiplePropertyInfo ,
    constructDOMHTMLInputElementMultiple    ,
    getDOMHTMLInputElementMultiple          ,
    setDOMHTMLInputElementMultiple          ,


-- ** Name
    DOMHTMLInputElementNamePropertyInfo     ,
    constructDOMHTMLInputElementName        ,
    getDOMHTMLInputElementName              ,
    setDOMHTMLInputElementName              ,


-- ** Pattern
    DOMHTMLInputElementPatternPropertyInfo  ,
    constructDOMHTMLInputElementPattern     ,
    getDOMHTMLInputElementPattern           ,
    setDOMHTMLInputElementPattern           ,


-- ** Placeholder
    DOMHTMLInputElementPlaceholderPropertyInfo,
    constructDOMHTMLInputElementPlaceholder ,
    getDOMHTMLInputElementPlaceholder       ,
    setDOMHTMLInputElementPlaceholder       ,


-- ** ReadOnly
    DOMHTMLInputElementReadOnlyPropertyInfo ,
    constructDOMHTMLInputElementReadOnly    ,
    getDOMHTMLInputElementReadOnly          ,
    setDOMHTMLInputElementReadOnly          ,


-- ** Required
    DOMHTMLInputElementRequiredPropertyInfo ,
    constructDOMHTMLInputElementRequired    ,
    getDOMHTMLInputElementRequired          ,
    setDOMHTMLInputElementRequired          ,


-- ** Size
    DOMHTMLInputElementSizePropertyInfo     ,
    constructDOMHTMLInputElementSize        ,
    getDOMHTMLInputElementSize              ,
    setDOMHTMLInputElementSize              ,


-- ** Src
    DOMHTMLInputElementSrcPropertyInfo      ,
    constructDOMHTMLInputElementSrc         ,
    getDOMHTMLInputElementSrc               ,
    setDOMHTMLInputElementSrc               ,


-- ** Step
    DOMHTMLInputElementStepPropertyInfo     ,
    constructDOMHTMLInputElementStep        ,
    getDOMHTMLInputElementStep              ,
    setDOMHTMLInputElementStep              ,


-- ** Type
    DOMHTMLInputElementTypePropertyInfo     ,
    constructDOMHTMLInputElementType        ,
    getDOMHTMLInputElementType              ,
    setDOMHTMLInputElementType              ,


-- ** UseMap
    DOMHTMLInputElementUseMapPropertyInfo   ,
    constructDOMHTMLInputElementUseMap      ,
    getDOMHTMLInputElementUseMap            ,
    setDOMHTMLInputElementUseMap            ,


-- ** ValidationMessage
    DOMHTMLInputElementValidationMessagePropertyInfo,
    getDOMHTMLInputElementValidationMessage ,


-- ** Value
    DOMHTMLInputElementValuePropertyInfo    ,
    constructDOMHTMLInputElementValue       ,
    getDOMHTMLInputElementValue             ,
    setDOMHTMLInputElementValue             ,


-- ** ValueAsNumber
    DOMHTMLInputElementValueAsNumberPropertyInfo,
    constructDOMHTMLInputElementValueAsNumber,
    getDOMHTMLInputElementValueAsNumber     ,
    setDOMHTMLInputElementValueAsNumber     ,


-- ** Width
    DOMHTMLInputElementWidthPropertyInfo    ,
    constructDOMHTMLInputElementWidth       ,
    getDOMHTMLInputElementWidth             ,
    setDOMHTMLInputElementWidth             ,


-- ** WillValidate
    DOMHTMLInputElementWillValidatePropertyInfo,
    getDOMHTMLInputElementWillValidate      ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit2WebExtension.Types
import GI.WebKit2WebExtension.Callbacks
import qualified GI.GObject as GObject

newtype DOMHTMLInputElement = DOMHTMLInputElement (ForeignPtr DOMHTMLInputElement)
foreign import ccall "webkit_dom_html_input_element_get_type"
    c_webkit_dom_html_input_element_get_type :: IO GType

type instance ParentTypes DOMHTMLInputElement = DOMHTMLInputElementParentTypes
type DOMHTMLInputElementParentTypes = '[DOMHTMLElement, DOMElement, DOMNode, DOMObject, GObject.Object, DOMEventTarget]

instance GObject DOMHTMLInputElement where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_html_input_element_get_type
    

class GObject o => DOMHTMLInputElementK o
instance (GObject o, IsDescendantOf DOMHTMLInputElement o) => DOMHTMLInputElementK o

toDOMHTMLInputElement :: DOMHTMLInputElementK o => o -> IO DOMHTMLInputElement
toDOMHTMLInputElement = unsafeCastTo DOMHTMLInputElement

noDOMHTMLInputElement :: Maybe DOMHTMLInputElement
noDOMHTMLInputElement = Nothing

-- VVV Prop "accept"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLInputElementAccept :: (MonadIO m, DOMHTMLInputElementK o) => o -> m T.Text
getDOMHTMLInputElementAccept obj = liftIO $ getObjectPropertyString obj "accept"

setDOMHTMLInputElementAccept :: (MonadIO m, DOMHTMLInputElementK o) => o -> T.Text -> m ()
setDOMHTMLInputElementAccept obj val = liftIO $ setObjectPropertyString obj "accept" val

constructDOMHTMLInputElementAccept :: T.Text -> IO ([Char], GValue)
constructDOMHTMLInputElementAccept val = constructObjectPropertyString "accept" val

data DOMHTMLInputElementAcceptPropertyInfo
instance AttrInfo DOMHTMLInputElementAcceptPropertyInfo where
    type AttrAllowedOps DOMHTMLInputElementAcceptPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLInputElementAcceptPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLInputElementAcceptPropertyInfo = DOMHTMLInputElementK
    type AttrGetType DOMHTMLInputElementAcceptPropertyInfo = T.Text
    type AttrLabel DOMHTMLInputElementAcceptPropertyInfo = "DOMHTMLInputElement::accept"
    attrGet _ = getDOMHTMLInputElementAccept
    attrSet _ = setDOMHTMLInputElementAccept
    attrConstruct _ = constructDOMHTMLInputElementAccept

-- VVV Prop "align"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLInputElementAlign :: (MonadIO m, DOMHTMLInputElementK o) => o -> m T.Text
getDOMHTMLInputElementAlign obj = liftIO $ getObjectPropertyString obj "align"

setDOMHTMLInputElementAlign :: (MonadIO m, DOMHTMLInputElementK o) => o -> T.Text -> m ()
setDOMHTMLInputElementAlign obj val = liftIO $ setObjectPropertyString obj "align" val

constructDOMHTMLInputElementAlign :: T.Text -> IO ([Char], GValue)
constructDOMHTMLInputElementAlign val = constructObjectPropertyString "align" val

data DOMHTMLInputElementAlignPropertyInfo
instance AttrInfo DOMHTMLInputElementAlignPropertyInfo where
    type AttrAllowedOps DOMHTMLInputElementAlignPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLInputElementAlignPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLInputElementAlignPropertyInfo = DOMHTMLInputElementK
    type AttrGetType DOMHTMLInputElementAlignPropertyInfo = T.Text
    type AttrLabel DOMHTMLInputElementAlignPropertyInfo = "DOMHTMLInputElement::align"
    attrGet _ = getDOMHTMLInputElementAlign
    attrSet _ = setDOMHTMLInputElementAlign
    attrConstruct _ = constructDOMHTMLInputElementAlign

-- VVV Prop "alt"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLInputElementAlt :: (MonadIO m, DOMHTMLInputElementK o) => o -> m T.Text
getDOMHTMLInputElementAlt obj = liftIO $ getObjectPropertyString obj "alt"

setDOMHTMLInputElementAlt :: (MonadIO m, DOMHTMLInputElementK o) => o -> T.Text -> m ()
setDOMHTMLInputElementAlt obj val = liftIO $ setObjectPropertyString obj "alt" val

constructDOMHTMLInputElementAlt :: T.Text -> IO ([Char], GValue)
constructDOMHTMLInputElementAlt val = constructObjectPropertyString "alt" val

data DOMHTMLInputElementAltPropertyInfo
instance AttrInfo DOMHTMLInputElementAltPropertyInfo where
    type AttrAllowedOps DOMHTMLInputElementAltPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLInputElementAltPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLInputElementAltPropertyInfo = DOMHTMLInputElementK
    type AttrGetType DOMHTMLInputElementAltPropertyInfo = T.Text
    type AttrLabel DOMHTMLInputElementAltPropertyInfo = "DOMHTMLInputElement::alt"
    attrGet _ = getDOMHTMLInputElementAlt
    attrSet _ = setDOMHTMLInputElementAlt
    attrConstruct _ = constructDOMHTMLInputElementAlt

-- VVV Prop "autocapitalize"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLInputElementAutocapitalize :: (MonadIO m, DOMHTMLInputElementK o) => o -> m T.Text
getDOMHTMLInputElementAutocapitalize obj = liftIO $ getObjectPropertyString obj "autocapitalize"

setDOMHTMLInputElementAutocapitalize :: (MonadIO m, DOMHTMLInputElementK o) => o -> T.Text -> m ()
setDOMHTMLInputElementAutocapitalize obj val = liftIO $ setObjectPropertyString obj "autocapitalize" val

constructDOMHTMLInputElementAutocapitalize :: T.Text -> IO ([Char], GValue)
constructDOMHTMLInputElementAutocapitalize val = constructObjectPropertyString "autocapitalize" val

data DOMHTMLInputElementAutocapitalizePropertyInfo
instance AttrInfo DOMHTMLInputElementAutocapitalizePropertyInfo where
    type AttrAllowedOps DOMHTMLInputElementAutocapitalizePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLInputElementAutocapitalizePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLInputElementAutocapitalizePropertyInfo = DOMHTMLInputElementK
    type AttrGetType DOMHTMLInputElementAutocapitalizePropertyInfo = T.Text
    type AttrLabel DOMHTMLInputElementAutocapitalizePropertyInfo = "DOMHTMLInputElement::autocapitalize"
    attrGet _ = getDOMHTMLInputElementAutocapitalize
    attrSet _ = setDOMHTMLInputElementAutocapitalize
    attrConstruct _ = constructDOMHTMLInputElementAutocapitalize

-- VVV Prop "autocomplete"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLInputElementAutocomplete :: (MonadIO m, DOMHTMLInputElementK o) => o -> m T.Text
getDOMHTMLInputElementAutocomplete obj = liftIO $ getObjectPropertyString obj "autocomplete"

setDOMHTMLInputElementAutocomplete :: (MonadIO m, DOMHTMLInputElementK o) => o -> T.Text -> m ()
setDOMHTMLInputElementAutocomplete obj val = liftIO $ setObjectPropertyString obj "autocomplete" val

constructDOMHTMLInputElementAutocomplete :: T.Text -> IO ([Char], GValue)
constructDOMHTMLInputElementAutocomplete val = constructObjectPropertyString "autocomplete" val

data DOMHTMLInputElementAutocompletePropertyInfo
instance AttrInfo DOMHTMLInputElementAutocompletePropertyInfo where
    type AttrAllowedOps DOMHTMLInputElementAutocompletePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLInputElementAutocompletePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLInputElementAutocompletePropertyInfo = DOMHTMLInputElementK
    type AttrGetType DOMHTMLInputElementAutocompletePropertyInfo = T.Text
    type AttrLabel DOMHTMLInputElementAutocompletePropertyInfo = "DOMHTMLInputElement::autocomplete"
    attrGet _ = getDOMHTMLInputElementAutocomplete
    attrSet _ = setDOMHTMLInputElementAutocomplete
    attrConstruct _ = constructDOMHTMLInputElementAutocomplete

-- VVV Prop "autocorrect"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLInputElementAutocorrect :: (MonadIO m, DOMHTMLInputElementK o) => o -> m Bool
getDOMHTMLInputElementAutocorrect obj = liftIO $ getObjectPropertyBool obj "autocorrect"

setDOMHTMLInputElementAutocorrect :: (MonadIO m, DOMHTMLInputElementK o) => o -> Bool -> m ()
setDOMHTMLInputElementAutocorrect obj val = liftIO $ setObjectPropertyBool obj "autocorrect" val

constructDOMHTMLInputElementAutocorrect :: Bool -> IO ([Char], GValue)
constructDOMHTMLInputElementAutocorrect val = constructObjectPropertyBool "autocorrect" val

data DOMHTMLInputElementAutocorrectPropertyInfo
instance AttrInfo DOMHTMLInputElementAutocorrectPropertyInfo where
    type AttrAllowedOps DOMHTMLInputElementAutocorrectPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLInputElementAutocorrectPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint DOMHTMLInputElementAutocorrectPropertyInfo = DOMHTMLInputElementK
    type AttrGetType DOMHTMLInputElementAutocorrectPropertyInfo = Bool
    type AttrLabel DOMHTMLInputElementAutocorrectPropertyInfo = "DOMHTMLInputElement::autocorrect"
    attrGet _ = getDOMHTMLInputElementAutocorrect
    attrSet _ = setDOMHTMLInputElementAutocorrect
    attrConstruct _ = constructDOMHTMLInputElementAutocorrect

-- VVV Prop "autofocus"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLInputElementAutofocus :: (MonadIO m, DOMHTMLInputElementK o) => o -> m Bool
getDOMHTMLInputElementAutofocus obj = liftIO $ getObjectPropertyBool obj "autofocus"

setDOMHTMLInputElementAutofocus :: (MonadIO m, DOMHTMLInputElementK o) => o -> Bool -> m ()
setDOMHTMLInputElementAutofocus obj val = liftIO $ setObjectPropertyBool obj "autofocus" val

constructDOMHTMLInputElementAutofocus :: Bool -> IO ([Char], GValue)
constructDOMHTMLInputElementAutofocus val = constructObjectPropertyBool "autofocus" val

data DOMHTMLInputElementAutofocusPropertyInfo
instance AttrInfo DOMHTMLInputElementAutofocusPropertyInfo where
    type AttrAllowedOps DOMHTMLInputElementAutofocusPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLInputElementAutofocusPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint DOMHTMLInputElementAutofocusPropertyInfo = DOMHTMLInputElementK
    type AttrGetType DOMHTMLInputElementAutofocusPropertyInfo = Bool
    type AttrLabel DOMHTMLInputElementAutofocusPropertyInfo = "DOMHTMLInputElement::autofocus"
    attrGet _ = getDOMHTMLInputElementAutofocus
    attrSet _ = setDOMHTMLInputElementAutofocus
    attrConstruct _ = constructDOMHTMLInputElementAutofocus

-- VVV Prop "capture"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLInputElementCapture :: (MonadIO m, DOMHTMLInputElementK o) => o -> m Bool
getDOMHTMLInputElementCapture obj = liftIO $ getObjectPropertyBool obj "capture"

setDOMHTMLInputElementCapture :: (MonadIO m, DOMHTMLInputElementK o) => o -> Bool -> m ()
setDOMHTMLInputElementCapture obj val = liftIO $ setObjectPropertyBool obj "capture" val

constructDOMHTMLInputElementCapture :: Bool -> IO ([Char], GValue)
constructDOMHTMLInputElementCapture val = constructObjectPropertyBool "capture" val

data DOMHTMLInputElementCapturePropertyInfo
instance AttrInfo DOMHTMLInputElementCapturePropertyInfo where
    type AttrAllowedOps DOMHTMLInputElementCapturePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLInputElementCapturePropertyInfo = (~) Bool
    type AttrBaseTypeConstraint DOMHTMLInputElementCapturePropertyInfo = DOMHTMLInputElementK
    type AttrGetType DOMHTMLInputElementCapturePropertyInfo = Bool
    type AttrLabel DOMHTMLInputElementCapturePropertyInfo = "DOMHTMLInputElement::capture"
    attrGet _ = getDOMHTMLInputElementCapture
    attrSet _ = setDOMHTMLInputElementCapture
    attrConstruct _ = constructDOMHTMLInputElementCapture

-- VVV Prop "checked"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLInputElementChecked :: (MonadIO m, DOMHTMLInputElementK o) => o -> m Bool
getDOMHTMLInputElementChecked obj = liftIO $ getObjectPropertyBool obj "checked"

setDOMHTMLInputElementChecked :: (MonadIO m, DOMHTMLInputElementK o) => o -> Bool -> m ()
setDOMHTMLInputElementChecked obj val = liftIO $ setObjectPropertyBool obj "checked" val

constructDOMHTMLInputElementChecked :: Bool -> IO ([Char], GValue)
constructDOMHTMLInputElementChecked val = constructObjectPropertyBool "checked" val

data DOMHTMLInputElementCheckedPropertyInfo
instance AttrInfo DOMHTMLInputElementCheckedPropertyInfo where
    type AttrAllowedOps DOMHTMLInputElementCheckedPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLInputElementCheckedPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint DOMHTMLInputElementCheckedPropertyInfo = DOMHTMLInputElementK
    type AttrGetType DOMHTMLInputElementCheckedPropertyInfo = Bool
    type AttrLabel DOMHTMLInputElementCheckedPropertyInfo = "DOMHTMLInputElement::checked"
    attrGet _ = getDOMHTMLInputElementChecked
    attrSet _ = setDOMHTMLInputElementChecked
    attrConstruct _ = constructDOMHTMLInputElementChecked

-- VVV Prop "default-checked"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLInputElementDefaultChecked :: (MonadIO m, DOMHTMLInputElementK o) => o -> m Bool
getDOMHTMLInputElementDefaultChecked obj = liftIO $ getObjectPropertyBool obj "default-checked"

setDOMHTMLInputElementDefaultChecked :: (MonadIO m, DOMHTMLInputElementK o) => o -> Bool -> m ()
setDOMHTMLInputElementDefaultChecked obj val = liftIO $ setObjectPropertyBool obj "default-checked" val

constructDOMHTMLInputElementDefaultChecked :: Bool -> IO ([Char], GValue)
constructDOMHTMLInputElementDefaultChecked val = constructObjectPropertyBool "default-checked" val

data DOMHTMLInputElementDefaultCheckedPropertyInfo
instance AttrInfo DOMHTMLInputElementDefaultCheckedPropertyInfo where
    type AttrAllowedOps DOMHTMLInputElementDefaultCheckedPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLInputElementDefaultCheckedPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint DOMHTMLInputElementDefaultCheckedPropertyInfo = DOMHTMLInputElementK
    type AttrGetType DOMHTMLInputElementDefaultCheckedPropertyInfo = Bool
    type AttrLabel DOMHTMLInputElementDefaultCheckedPropertyInfo = "DOMHTMLInputElement::default-checked"
    attrGet _ = getDOMHTMLInputElementDefaultChecked
    attrSet _ = setDOMHTMLInputElementDefaultChecked
    attrConstruct _ = constructDOMHTMLInputElementDefaultChecked

-- VVV Prop "default-value"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLInputElementDefaultValue :: (MonadIO m, DOMHTMLInputElementK o) => o -> m T.Text
getDOMHTMLInputElementDefaultValue obj = liftIO $ getObjectPropertyString obj "default-value"

setDOMHTMLInputElementDefaultValue :: (MonadIO m, DOMHTMLInputElementK o) => o -> T.Text -> m ()
setDOMHTMLInputElementDefaultValue obj val = liftIO $ setObjectPropertyString obj "default-value" val

constructDOMHTMLInputElementDefaultValue :: T.Text -> IO ([Char], GValue)
constructDOMHTMLInputElementDefaultValue val = constructObjectPropertyString "default-value" val

data DOMHTMLInputElementDefaultValuePropertyInfo
instance AttrInfo DOMHTMLInputElementDefaultValuePropertyInfo where
    type AttrAllowedOps DOMHTMLInputElementDefaultValuePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLInputElementDefaultValuePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLInputElementDefaultValuePropertyInfo = DOMHTMLInputElementK
    type AttrGetType DOMHTMLInputElementDefaultValuePropertyInfo = T.Text
    type AttrLabel DOMHTMLInputElementDefaultValuePropertyInfo = "DOMHTMLInputElement::default-value"
    attrGet _ = getDOMHTMLInputElementDefaultValue
    attrSet _ = setDOMHTMLInputElementDefaultValue
    attrConstruct _ = constructDOMHTMLInputElementDefaultValue

-- VVV Prop "dir-name"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLInputElementDirName :: (MonadIO m, DOMHTMLInputElementK o) => o -> m T.Text
getDOMHTMLInputElementDirName obj = liftIO $ getObjectPropertyString obj "dir-name"

setDOMHTMLInputElementDirName :: (MonadIO m, DOMHTMLInputElementK o) => o -> T.Text -> m ()
setDOMHTMLInputElementDirName obj val = liftIO $ setObjectPropertyString obj "dir-name" val

constructDOMHTMLInputElementDirName :: T.Text -> IO ([Char], GValue)
constructDOMHTMLInputElementDirName val = constructObjectPropertyString "dir-name" val

data DOMHTMLInputElementDirNamePropertyInfo
instance AttrInfo DOMHTMLInputElementDirNamePropertyInfo where
    type AttrAllowedOps DOMHTMLInputElementDirNamePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLInputElementDirNamePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLInputElementDirNamePropertyInfo = DOMHTMLInputElementK
    type AttrGetType DOMHTMLInputElementDirNamePropertyInfo = T.Text
    type AttrLabel DOMHTMLInputElementDirNamePropertyInfo = "DOMHTMLInputElement::dir-name"
    attrGet _ = getDOMHTMLInputElementDirName
    attrSet _ = setDOMHTMLInputElementDirName
    attrConstruct _ = constructDOMHTMLInputElementDirName

-- VVV Prop "disabled"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLInputElementDisabled :: (MonadIO m, DOMHTMLInputElementK o) => o -> m Bool
getDOMHTMLInputElementDisabled obj = liftIO $ getObjectPropertyBool obj "disabled"

setDOMHTMLInputElementDisabled :: (MonadIO m, DOMHTMLInputElementK o) => o -> Bool -> m ()
setDOMHTMLInputElementDisabled obj val = liftIO $ setObjectPropertyBool obj "disabled" val

constructDOMHTMLInputElementDisabled :: Bool -> IO ([Char], GValue)
constructDOMHTMLInputElementDisabled val = constructObjectPropertyBool "disabled" val

data DOMHTMLInputElementDisabledPropertyInfo
instance AttrInfo DOMHTMLInputElementDisabledPropertyInfo where
    type AttrAllowedOps DOMHTMLInputElementDisabledPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLInputElementDisabledPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint DOMHTMLInputElementDisabledPropertyInfo = DOMHTMLInputElementK
    type AttrGetType DOMHTMLInputElementDisabledPropertyInfo = Bool
    type AttrLabel DOMHTMLInputElementDisabledPropertyInfo = "DOMHTMLInputElement::disabled"
    attrGet _ = getDOMHTMLInputElementDisabled
    attrSet _ = setDOMHTMLInputElementDisabled
    attrConstruct _ = constructDOMHTMLInputElementDisabled

-- VVV Prop "files"
   -- Type: TInterface "WebKit2WebExtension" "DOMFileList"
   -- Flags: [PropertyReadable]

getDOMHTMLInputElementFiles :: (MonadIO m, DOMHTMLInputElementK o) => o -> m DOMFileList
getDOMHTMLInputElementFiles obj = liftIO $ getObjectPropertyObject obj "files" DOMFileList

data DOMHTMLInputElementFilesPropertyInfo
instance AttrInfo DOMHTMLInputElementFilesPropertyInfo where
    type AttrAllowedOps DOMHTMLInputElementFilesPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLInputElementFilesPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLInputElementFilesPropertyInfo = DOMHTMLInputElementK
    type AttrGetType DOMHTMLInputElementFilesPropertyInfo = DOMFileList
    type AttrLabel DOMHTMLInputElementFilesPropertyInfo = "DOMHTMLInputElement::files"
    attrGet _ = getDOMHTMLInputElementFiles
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "form"
   -- Type: TInterface "WebKit2WebExtension" "DOMHTMLFormElement"
   -- Flags: [PropertyReadable]

getDOMHTMLInputElementForm :: (MonadIO m, DOMHTMLInputElementK o) => o -> m DOMHTMLFormElement
getDOMHTMLInputElementForm obj = liftIO $ getObjectPropertyObject obj "form" DOMHTMLFormElement

data DOMHTMLInputElementFormPropertyInfo
instance AttrInfo DOMHTMLInputElementFormPropertyInfo where
    type AttrAllowedOps DOMHTMLInputElementFormPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLInputElementFormPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLInputElementFormPropertyInfo = DOMHTMLInputElementK
    type AttrGetType DOMHTMLInputElementFormPropertyInfo = DOMHTMLFormElement
    type AttrLabel DOMHTMLInputElementFormPropertyInfo = "DOMHTMLInputElement::form"
    attrGet _ = getDOMHTMLInputElementForm
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "form-action"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLInputElementFormAction :: (MonadIO m, DOMHTMLInputElementK o) => o -> m T.Text
getDOMHTMLInputElementFormAction obj = liftIO $ getObjectPropertyString obj "form-action"

setDOMHTMLInputElementFormAction :: (MonadIO m, DOMHTMLInputElementK o) => o -> T.Text -> m ()
setDOMHTMLInputElementFormAction obj val = liftIO $ setObjectPropertyString obj "form-action" val

constructDOMHTMLInputElementFormAction :: T.Text -> IO ([Char], GValue)
constructDOMHTMLInputElementFormAction val = constructObjectPropertyString "form-action" val

data DOMHTMLInputElementFormActionPropertyInfo
instance AttrInfo DOMHTMLInputElementFormActionPropertyInfo where
    type AttrAllowedOps DOMHTMLInputElementFormActionPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLInputElementFormActionPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLInputElementFormActionPropertyInfo = DOMHTMLInputElementK
    type AttrGetType DOMHTMLInputElementFormActionPropertyInfo = T.Text
    type AttrLabel DOMHTMLInputElementFormActionPropertyInfo = "DOMHTMLInputElement::form-action"
    attrGet _ = getDOMHTMLInputElementFormAction
    attrSet _ = setDOMHTMLInputElementFormAction
    attrConstruct _ = constructDOMHTMLInputElementFormAction

-- VVV Prop "form-enctype"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLInputElementFormEnctype :: (MonadIO m, DOMHTMLInputElementK o) => o -> m T.Text
getDOMHTMLInputElementFormEnctype obj = liftIO $ getObjectPropertyString obj "form-enctype"

setDOMHTMLInputElementFormEnctype :: (MonadIO m, DOMHTMLInputElementK o) => o -> T.Text -> m ()
setDOMHTMLInputElementFormEnctype obj val = liftIO $ setObjectPropertyString obj "form-enctype" val

constructDOMHTMLInputElementFormEnctype :: T.Text -> IO ([Char], GValue)
constructDOMHTMLInputElementFormEnctype val = constructObjectPropertyString "form-enctype" val

data DOMHTMLInputElementFormEnctypePropertyInfo
instance AttrInfo DOMHTMLInputElementFormEnctypePropertyInfo where
    type AttrAllowedOps DOMHTMLInputElementFormEnctypePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLInputElementFormEnctypePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLInputElementFormEnctypePropertyInfo = DOMHTMLInputElementK
    type AttrGetType DOMHTMLInputElementFormEnctypePropertyInfo = T.Text
    type AttrLabel DOMHTMLInputElementFormEnctypePropertyInfo = "DOMHTMLInputElement::form-enctype"
    attrGet _ = getDOMHTMLInputElementFormEnctype
    attrSet _ = setDOMHTMLInputElementFormEnctype
    attrConstruct _ = constructDOMHTMLInputElementFormEnctype

-- VVV Prop "form-method"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLInputElementFormMethod :: (MonadIO m, DOMHTMLInputElementK o) => o -> m T.Text
getDOMHTMLInputElementFormMethod obj = liftIO $ getObjectPropertyString obj "form-method"

setDOMHTMLInputElementFormMethod :: (MonadIO m, DOMHTMLInputElementK o) => o -> T.Text -> m ()
setDOMHTMLInputElementFormMethod obj val = liftIO $ setObjectPropertyString obj "form-method" val

constructDOMHTMLInputElementFormMethod :: T.Text -> IO ([Char], GValue)
constructDOMHTMLInputElementFormMethod val = constructObjectPropertyString "form-method" val

data DOMHTMLInputElementFormMethodPropertyInfo
instance AttrInfo DOMHTMLInputElementFormMethodPropertyInfo where
    type AttrAllowedOps DOMHTMLInputElementFormMethodPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLInputElementFormMethodPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLInputElementFormMethodPropertyInfo = DOMHTMLInputElementK
    type AttrGetType DOMHTMLInputElementFormMethodPropertyInfo = T.Text
    type AttrLabel DOMHTMLInputElementFormMethodPropertyInfo = "DOMHTMLInputElement::form-method"
    attrGet _ = getDOMHTMLInputElementFormMethod
    attrSet _ = setDOMHTMLInputElementFormMethod
    attrConstruct _ = constructDOMHTMLInputElementFormMethod

-- VVV Prop "form-no-validate"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLInputElementFormNoValidate :: (MonadIO m, DOMHTMLInputElementK o) => o -> m Bool
getDOMHTMLInputElementFormNoValidate obj = liftIO $ getObjectPropertyBool obj "form-no-validate"

setDOMHTMLInputElementFormNoValidate :: (MonadIO m, DOMHTMLInputElementK o) => o -> Bool -> m ()
setDOMHTMLInputElementFormNoValidate obj val = liftIO $ setObjectPropertyBool obj "form-no-validate" val

constructDOMHTMLInputElementFormNoValidate :: Bool -> IO ([Char], GValue)
constructDOMHTMLInputElementFormNoValidate val = constructObjectPropertyBool "form-no-validate" val

data DOMHTMLInputElementFormNoValidatePropertyInfo
instance AttrInfo DOMHTMLInputElementFormNoValidatePropertyInfo where
    type AttrAllowedOps DOMHTMLInputElementFormNoValidatePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLInputElementFormNoValidatePropertyInfo = (~) Bool
    type AttrBaseTypeConstraint DOMHTMLInputElementFormNoValidatePropertyInfo = DOMHTMLInputElementK
    type AttrGetType DOMHTMLInputElementFormNoValidatePropertyInfo = Bool
    type AttrLabel DOMHTMLInputElementFormNoValidatePropertyInfo = "DOMHTMLInputElement::form-no-validate"
    attrGet _ = getDOMHTMLInputElementFormNoValidate
    attrSet _ = setDOMHTMLInputElementFormNoValidate
    attrConstruct _ = constructDOMHTMLInputElementFormNoValidate

-- VVV Prop "form-target"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLInputElementFormTarget :: (MonadIO m, DOMHTMLInputElementK o) => o -> m T.Text
getDOMHTMLInputElementFormTarget obj = liftIO $ getObjectPropertyString obj "form-target"

setDOMHTMLInputElementFormTarget :: (MonadIO m, DOMHTMLInputElementK o) => o -> T.Text -> m ()
setDOMHTMLInputElementFormTarget obj val = liftIO $ setObjectPropertyString obj "form-target" val

constructDOMHTMLInputElementFormTarget :: T.Text -> IO ([Char], GValue)
constructDOMHTMLInputElementFormTarget val = constructObjectPropertyString "form-target" val

data DOMHTMLInputElementFormTargetPropertyInfo
instance AttrInfo DOMHTMLInputElementFormTargetPropertyInfo where
    type AttrAllowedOps DOMHTMLInputElementFormTargetPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLInputElementFormTargetPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLInputElementFormTargetPropertyInfo = DOMHTMLInputElementK
    type AttrGetType DOMHTMLInputElementFormTargetPropertyInfo = T.Text
    type AttrLabel DOMHTMLInputElementFormTargetPropertyInfo = "DOMHTMLInputElement::form-target"
    attrGet _ = getDOMHTMLInputElementFormTarget
    attrSet _ = setDOMHTMLInputElementFormTarget
    attrConstruct _ = constructDOMHTMLInputElementFormTarget

-- VVV Prop "height"
   -- Type: TBasicType TUInt64
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLInputElementHeight :: (MonadIO m, DOMHTMLInputElementK o) => o -> m Word64
getDOMHTMLInputElementHeight obj = liftIO $ getObjectPropertyUInt64 obj "height"

setDOMHTMLInputElementHeight :: (MonadIO m, DOMHTMLInputElementK o) => o -> Word64 -> m ()
setDOMHTMLInputElementHeight obj val = liftIO $ setObjectPropertyUInt64 obj "height" val

constructDOMHTMLInputElementHeight :: Word64 -> IO ([Char], GValue)
constructDOMHTMLInputElementHeight val = constructObjectPropertyUInt64 "height" val

data DOMHTMLInputElementHeightPropertyInfo
instance AttrInfo DOMHTMLInputElementHeightPropertyInfo where
    type AttrAllowedOps DOMHTMLInputElementHeightPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLInputElementHeightPropertyInfo = (~) Word64
    type AttrBaseTypeConstraint DOMHTMLInputElementHeightPropertyInfo = DOMHTMLInputElementK
    type AttrGetType DOMHTMLInputElementHeightPropertyInfo = Word64
    type AttrLabel DOMHTMLInputElementHeightPropertyInfo = "DOMHTMLInputElement::height"
    attrGet _ = getDOMHTMLInputElementHeight
    attrSet _ = setDOMHTMLInputElementHeight
    attrConstruct _ = constructDOMHTMLInputElementHeight

-- VVV Prop "incremental"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLInputElementIncremental :: (MonadIO m, DOMHTMLInputElementK o) => o -> m Bool
getDOMHTMLInputElementIncremental obj = liftIO $ getObjectPropertyBool obj "incremental"

setDOMHTMLInputElementIncremental :: (MonadIO m, DOMHTMLInputElementK o) => o -> Bool -> m ()
setDOMHTMLInputElementIncremental obj val = liftIO $ setObjectPropertyBool obj "incremental" val

constructDOMHTMLInputElementIncremental :: Bool -> IO ([Char], GValue)
constructDOMHTMLInputElementIncremental val = constructObjectPropertyBool "incremental" val

data DOMHTMLInputElementIncrementalPropertyInfo
instance AttrInfo DOMHTMLInputElementIncrementalPropertyInfo where
    type AttrAllowedOps DOMHTMLInputElementIncrementalPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLInputElementIncrementalPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint DOMHTMLInputElementIncrementalPropertyInfo = DOMHTMLInputElementK
    type AttrGetType DOMHTMLInputElementIncrementalPropertyInfo = Bool
    type AttrLabel DOMHTMLInputElementIncrementalPropertyInfo = "DOMHTMLInputElement::incremental"
    attrGet _ = getDOMHTMLInputElementIncremental
    attrSet _ = setDOMHTMLInputElementIncremental
    attrConstruct _ = constructDOMHTMLInputElementIncremental

-- VVV Prop "indeterminate"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLInputElementIndeterminate :: (MonadIO m, DOMHTMLInputElementK o) => o -> m Bool
getDOMHTMLInputElementIndeterminate obj = liftIO $ getObjectPropertyBool obj "indeterminate"

setDOMHTMLInputElementIndeterminate :: (MonadIO m, DOMHTMLInputElementK o) => o -> Bool -> m ()
setDOMHTMLInputElementIndeterminate obj val = liftIO $ setObjectPropertyBool obj "indeterminate" val

constructDOMHTMLInputElementIndeterminate :: Bool -> IO ([Char], GValue)
constructDOMHTMLInputElementIndeterminate val = constructObjectPropertyBool "indeterminate" val

data DOMHTMLInputElementIndeterminatePropertyInfo
instance AttrInfo DOMHTMLInputElementIndeterminatePropertyInfo where
    type AttrAllowedOps DOMHTMLInputElementIndeterminatePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLInputElementIndeterminatePropertyInfo = (~) Bool
    type AttrBaseTypeConstraint DOMHTMLInputElementIndeterminatePropertyInfo = DOMHTMLInputElementK
    type AttrGetType DOMHTMLInputElementIndeterminatePropertyInfo = Bool
    type AttrLabel DOMHTMLInputElementIndeterminatePropertyInfo = "DOMHTMLInputElement::indeterminate"
    attrGet _ = getDOMHTMLInputElementIndeterminate
    attrSet _ = setDOMHTMLInputElementIndeterminate
    attrConstruct _ = constructDOMHTMLInputElementIndeterminate

-- VVV Prop "labels"
   -- Type: TInterface "WebKit2WebExtension" "DOMNodeList"
   -- Flags: [PropertyReadable]

getDOMHTMLInputElementLabels :: (MonadIO m, DOMHTMLInputElementK o) => o -> m DOMNodeList
getDOMHTMLInputElementLabels obj = liftIO $ getObjectPropertyObject obj "labels" DOMNodeList

data DOMHTMLInputElementLabelsPropertyInfo
instance AttrInfo DOMHTMLInputElementLabelsPropertyInfo where
    type AttrAllowedOps DOMHTMLInputElementLabelsPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLInputElementLabelsPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLInputElementLabelsPropertyInfo = DOMHTMLInputElementK
    type AttrGetType DOMHTMLInputElementLabelsPropertyInfo = DOMNodeList
    type AttrLabel DOMHTMLInputElementLabelsPropertyInfo = "DOMHTMLInputElement::labels"
    attrGet _ = getDOMHTMLInputElementLabels
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "list"
   -- Type: TInterface "WebKit2WebExtension" "DOMHTMLElement"
   -- Flags: [PropertyReadable]

getDOMHTMLInputElementList :: (MonadIO m, DOMHTMLInputElementK o) => o -> m DOMHTMLElement
getDOMHTMLInputElementList obj = liftIO $ getObjectPropertyObject obj "list" DOMHTMLElement

data DOMHTMLInputElementListPropertyInfo
instance AttrInfo DOMHTMLInputElementListPropertyInfo where
    type AttrAllowedOps DOMHTMLInputElementListPropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLInputElementListPropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLInputElementListPropertyInfo = DOMHTMLInputElementK
    type AttrGetType DOMHTMLInputElementListPropertyInfo = DOMHTMLElement
    type AttrLabel DOMHTMLInputElementListPropertyInfo = "DOMHTMLInputElement::list"
    attrGet _ = getDOMHTMLInputElementList
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "max"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLInputElementMax :: (MonadIO m, DOMHTMLInputElementK o) => o -> m T.Text
getDOMHTMLInputElementMax obj = liftIO $ getObjectPropertyString obj "max"

setDOMHTMLInputElementMax :: (MonadIO m, DOMHTMLInputElementK o) => o -> T.Text -> m ()
setDOMHTMLInputElementMax obj val = liftIO $ setObjectPropertyString obj "max" val

constructDOMHTMLInputElementMax :: T.Text -> IO ([Char], GValue)
constructDOMHTMLInputElementMax val = constructObjectPropertyString "max" val

data DOMHTMLInputElementMaxPropertyInfo
instance AttrInfo DOMHTMLInputElementMaxPropertyInfo where
    type AttrAllowedOps DOMHTMLInputElementMaxPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLInputElementMaxPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLInputElementMaxPropertyInfo = DOMHTMLInputElementK
    type AttrGetType DOMHTMLInputElementMaxPropertyInfo = T.Text
    type AttrLabel DOMHTMLInputElementMaxPropertyInfo = "DOMHTMLInputElement::max"
    attrGet _ = getDOMHTMLInputElementMax
    attrSet _ = setDOMHTMLInputElementMax
    attrConstruct _ = constructDOMHTMLInputElementMax

-- VVV Prop "max-length"
   -- Type: TBasicType TInt64
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLInputElementMaxLength :: (MonadIO m, DOMHTMLInputElementK o) => o -> m Int64
getDOMHTMLInputElementMaxLength obj = liftIO $ getObjectPropertyInt64 obj "max-length"

setDOMHTMLInputElementMaxLength :: (MonadIO m, DOMHTMLInputElementK o) => o -> Int64 -> m ()
setDOMHTMLInputElementMaxLength obj val = liftIO $ setObjectPropertyInt64 obj "max-length" val

constructDOMHTMLInputElementMaxLength :: Int64 -> IO ([Char], GValue)
constructDOMHTMLInputElementMaxLength val = constructObjectPropertyInt64 "max-length" val

data DOMHTMLInputElementMaxLengthPropertyInfo
instance AttrInfo DOMHTMLInputElementMaxLengthPropertyInfo where
    type AttrAllowedOps DOMHTMLInputElementMaxLengthPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLInputElementMaxLengthPropertyInfo = (~) Int64
    type AttrBaseTypeConstraint DOMHTMLInputElementMaxLengthPropertyInfo = DOMHTMLInputElementK
    type AttrGetType DOMHTMLInputElementMaxLengthPropertyInfo = Int64
    type AttrLabel DOMHTMLInputElementMaxLengthPropertyInfo = "DOMHTMLInputElement::max-length"
    attrGet _ = getDOMHTMLInputElementMaxLength
    attrSet _ = setDOMHTMLInputElementMaxLength
    attrConstruct _ = constructDOMHTMLInputElementMaxLength

-- VVV Prop "min"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLInputElementMin :: (MonadIO m, DOMHTMLInputElementK o) => o -> m T.Text
getDOMHTMLInputElementMin obj = liftIO $ getObjectPropertyString obj "min"

setDOMHTMLInputElementMin :: (MonadIO m, DOMHTMLInputElementK o) => o -> T.Text -> m ()
setDOMHTMLInputElementMin obj val = liftIO $ setObjectPropertyString obj "min" val

constructDOMHTMLInputElementMin :: T.Text -> IO ([Char], GValue)
constructDOMHTMLInputElementMin val = constructObjectPropertyString "min" val

data DOMHTMLInputElementMinPropertyInfo
instance AttrInfo DOMHTMLInputElementMinPropertyInfo where
    type AttrAllowedOps DOMHTMLInputElementMinPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLInputElementMinPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLInputElementMinPropertyInfo = DOMHTMLInputElementK
    type AttrGetType DOMHTMLInputElementMinPropertyInfo = T.Text
    type AttrLabel DOMHTMLInputElementMinPropertyInfo = "DOMHTMLInputElement::min"
    attrGet _ = getDOMHTMLInputElementMin
    attrSet _ = setDOMHTMLInputElementMin
    attrConstruct _ = constructDOMHTMLInputElementMin

-- VVV Prop "multiple"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLInputElementMultiple :: (MonadIO m, DOMHTMLInputElementK o) => o -> m Bool
getDOMHTMLInputElementMultiple obj = liftIO $ getObjectPropertyBool obj "multiple"

setDOMHTMLInputElementMultiple :: (MonadIO m, DOMHTMLInputElementK o) => o -> Bool -> m ()
setDOMHTMLInputElementMultiple obj val = liftIO $ setObjectPropertyBool obj "multiple" val

constructDOMHTMLInputElementMultiple :: Bool -> IO ([Char], GValue)
constructDOMHTMLInputElementMultiple val = constructObjectPropertyBool "multiple" val

data DOMHTMLInputElementMultiplePropertyInfo
instance AttrInfo DOMHTMLInputElementMultiplePropertyInfo where
    type AttrAllowedOps DOMHTMLInputElementMultiplePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLInputElementMultiplePropertyInfo = (~) Bool
    type AttrBaseTypeConstraint DOMHTMLInputElementMultiplePropertyInfo = DOMHTMLInputElementK
    type AttrGetType DOMHTMLInputElementMultiplePropertyInfo = Bool
    type AttrLabel DOMHTMLInputElementMultiplePropertyInfo = "DOMHTMLInputElement::multiple"
    attrGet _ = getDOMHTMLInputElementMultiple
    attrSet _ = setDOMHTMLInputElementMultiple
    attrConstruct _ = constructDOMHTMLInputElementMultiple

-- VVV Prop "name"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLInputElementName :: (MonadIO m, DOMHTMLInputElementK o) => o -> m T.Text
getDOMHTMLInputElementName obj = liftIO $ getObjectPropertyString obj "name"

setDOMHTMLInputElementName :: (MonadIO m, DOMHTMLInputElementK o) => o -> T.Text -> m ()
setDOMHTMLInputElementName obj val = liftIO $ setObjectPropertyString obj "name" val

constructDOMHTMLInputElementName :: T.Text -> IO ([Char], GValue)
constructDOMHTMLInputElementName val = constructObjectPropertyString "name" val

data DOMHTMLInputElementNamePropertyInfo
instance AttrInfo DOMHTMLInputElementNamePropertyInfo where
    type AttrAllowedOps DOMHTMLInputElementNamePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLInputElementNamePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLInputElementNamePropertyInfo = DOMHTMLInputElementK
    type AttrGetType DOMHTMLInputElementNamePropertyInfo = T.Text
    type AttrLabel DOMHTMLInputElementNamePropertyInfo = "DOMHTMLInputElement::name"
    attrGet _ = getDOMHTMLInputElementName
    attrSet _ = setDOMHTMLInputElementName
    attrConstruct _ = constructDOMHTMLInputElementName

-- VVV Prop "pattern"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLInputElementPattern :: (MonadIO m, DOMHTMLInputElementK o) => o -> m T.Text
getDOMHTMLInputElementPattern obj = liftIO $ getObjectPropertyString obj "pattern"

setDOMHTMLInputElementPattern :: (MonadIO m, DOMHTMLInputElementK o) => o -> T.Text -> m ()
setDOMHTMLInputElementPattern obj val = liftIO $ setObjectPropertyString obj "pattern" val

constructDOMHTMLInputElementPattern :: T.Text -> IO ([Char], GValue)
constructDOMHTMLInputElementPattern val = constructObjectPropertyString "pattern" val

data DOMHTMLInputElementPatternPropertyInfo
instance AttrInfo DOMHTMLInputElementPatternPropertyInfo where
    type AttrAllowedOps DOMHTMLInputElementPatternPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLInputElementPatternPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLInputElementPatternPropertyInfo = DOMHTMLInputElementK
    type AttrGetType DOMHTMLInputElementPatternPropertyInfo = T.Text
    type AttrLabel DOMHTMLInputElementPatternPropertyInfo = "DOMHTMLInputElement::pattern"
    attrGet _ = getDOMHTMLInputElementPattern
    attrSet _ = setDOMHTMLInputElementPattern
    attrConstruct _ = constructDOMHTMLInputElementPattern

-- VVV Prop "placeholder"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLInputElementPlaceholder :: (MonadIO m, DOMHTMLInputElementK o) => o -> m T.Text
getDOMHTMLInputElementPlaceholder obj = liftIO $ getObjectPropertyString obj "placeholder"

setDOMHTMLInputElementPlaceholder :: (MonadIO m, DOMHTMLInputElementK o) => o -> T.Text -> m ()
setDOMHTMLInputElementPlaceholder obj val = liftIO $ setObjectPropertyString obj "placeholder" val

constructDOMHTMLInputElementPlaceholder :: T.Text -> IO ([Char], GValue)
constructDOMHTMLInputElementPlaceholder val = constructObjectPropertyString "placeholder" val

data DOMHTMLInputElementPlaceholderPropertyInfo
instance AttrInfo DOMHTMLInputElementPlaceholderPropertyInfo where
    type AttrAllowedOps DOMHTMLInputElementPlaceholderPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLInputElementPlaceholderPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLInputElementPlaceholderPropertyInfo = DOMHTMLInputElementK
    type AttrGetType DOMHTMLInputElementPlaceholderPropertyInfo = T.Text
    type AttrLabel DOMHTMLInputElementPlaceholderPropertyInfo = "DOMHTMLInputElement::placeholder"
    attrGet _ = getDOMHTMLInputElementPlaceholder
    attrSet _ = setDOMHTMLInputElementPlaceholder
    attrConstruct _ = constructDOMHTMLInputElementPlaceholder

-- VVV Prop "read-only"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLInputElementReadOnly :: (MonadIO m, DOMHTMLInputElementK o) => o -> m Bool
getDOMHTMLInputElementReadOnly obj = liftIO $ getObjectPropertyBool obj "read-only"

setDOMHTMLInputElementReadOnly :: (MonadIO m, DOMHTMLInputElementK o) => o -> Bool -> m ()
setDOMHTMLInputElementReadOnly obj val = liftIO $ setObjectPropertyBool obj "read-only" val

constructDOMHTMLInputElementReadOnly :: Bool -> IO ([Char], GValue)
constructDOMHTMLInputElementReadOnly val = constructObjectPropertyBool "read-only" val

data DOMHTMLInputElementReadOnlyPropertyInfo
instance AttrInfo DOMHTMLInputElementReadOnlyPropertyInfo where
    type AttrAllowedOps DOMHTMLInputElementReadOnlyPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLInputElementReadOnlyPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint DOMHTMLInputElementReadOnlyPropertyInfo = DOMHTMLInputElementK
    type AttrGetType DOMHTMLInputElementReadOnlyPropertyInfo = Bool
    type AttrLabel DOMHTMLInputElementReadOnlyPropertyInfo = "DOMHTMLInputElement::read-only"
    attrGet _ = getDOMHTMLInputElementReadOnly
    attrSet _ = setDOMHTMLInputElementReadOnly
    attrConstruct _ = constructDOMHTMLInputElementReadOnly

-- VVV Prop "required"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLInputElementRequired :: (MonadIO m, DOMHTMLInputElementK o) => o -> m Bool
getDOMHTMLInputElementRequired obj = liftIO $ getObjectPropertyBool obj "required"

setDOMHTMLInputElementRequired :: (MonadIO m, DOMHTMLInputElementK o) => o -> Bool -> m ()
setDOMHTMLInputElementRequired obj val = liftIO $ setObjectPropertyBool obj "required" val

constructDOMHTMLInputElementRequired :: Bool -> IO ([Char], GValue)
constructDOMHTMLInputElementRequired val = constructObjectPropertyBool "required" val

data DOMHTMLInputElementRequiredPropertyInfo
instance AttrInfo DOMHTMLInputElementRequiredPropertyInfo where
    type AttrAllowedOps DOMHTMLInputElementRequiredPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLInputElementRequiredPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint DOMHTMLInputElementRequiredPropertyInfo = DOMHTMLInputElementK
    type AttrGetType DOMHTMLInputElementRequiredPropertyInfo = Bool
    type AttrLabel DOMHTMLInputElementRequiredPropertyInfo = "DOMHTMLInputElement::required"
    attrGet _ = getDOMHTMLInputElementRequired
    attrSet _ = setDOMHTMLInputElementRequired
    attrConstruct _ = constructDOMHTMLInputElementRequired

-- VVV Prop "size"
   -- Type: TBasicType TUInt64
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLInputElementSize :: (MonadIO m, DOMHTMLInputElementK o) => o -> m Word64
getDOMHTMLInputElementSize obj = liftIO $ getObjectPropertyUInt64 obj "size"

setDOMHTMLInputElementSize :: (MonadIO m, DOMHTMLInputElementK o) => o -> Word64 -> m ()
setDOMHTMLInputElementSize obj val = liftIO $ setObjectPropertyUInt64 obj "size" val

constructDOMHTMLInputElementSize :: Word64 -> IO ([Char], GValue)
constructDOMHTMLInputElementSize val = constructObjectPropertyUInt64 "size" val

data DOMHTMLInputElementSizePropertyInfo
instance AttrInfo DOMHTMLInputElementSizePropertyInfo where
    type AttrAllowedOps DOMHTMLInputElementSizePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLInputElementSizePropertyInfo = (~) Word64
    type AttrBaseTypeConstraint DOMHTMLInputElementSizePropertyInfo = DOMHTMLInputElementK
    type AttrGetType DOMHTMLInputElementSizePropertyInfo = Word64
    type AttrLabel DOMHTMLInputElementSizePropertyInfo = "DOMHTMLInputElement::size"
    attrGet _ = getDOMHTMLInputElementSize
    attrSet _ = setDOMHTMLInputElementSize
    attrConstruct _ = constructDOMHTMLInputElementSize

-- VVV Prop "src"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLInputElementSrc :: (MonadIO m, DOMHTMLInputElementK o) => o -> m T.Text
getDOMHTMLInputElementSrc obj = liftIO $ getObjectPropertyString obj "src"

setDOMHTMLInputElementSrc :: (MonadIO m, DOMHTMLInputElementK o) => o -> T.Text -> m ()
setDOMHTMLInputElementSrc obj val = liftIO $ setObjectPropertyString obj "src" val

constructDOMHTMLInputElementSrc :: T.Text -> IO ([Char], GValue)
constructDOMHTMLInputElementSrc val = constructObjectPropertyString "src" val

data DOMHTMLInputElementSrcPropertyInfo
instance AttrInfo DOMHTMLInputElementSrcPropertyInfo where
    type AttrAllowedOps DOMHTMLInputElementSrcPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLInputElementSrcPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLInputElementSrcPropertyInfo = DOMHTMLInputElementK
    type AttrGetType DOMHTMLInputElementSrcPropertyInfo = T.Text
    type AttrLabel DOMHTMLInputElementSrcPropertyInfo = "DOMHTMLInputElement::src"
    attrGet _ = getDOMHTMLInputElementSrc
    attrSet _ = setDOMHTMLInputElementSrc
    attrConstruct _ = constructDOMHTMLInputElementSrc

-- VVV Prop "step"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLInputElementStep :: (MonadIO m, DOMHTMLInputElementK o) => o -> m T.Text
getDOMHTMLInputElementStep obj = liftIO $ getObjectPropertyString obj "step"

setDOMHTMLInputElementStep :: (MonadIO m, DOMHTMLInputElementK o) => o -> T.Text -> m ()
setDOMHTMLInputElementStep obj val = liftIO $ setObjectPropertyString obj "step" val

constructDOMHTMLInputElementStep :: T.Text -> IO ([Char], GValue)
constructDOMHTMLInputElementStep val = constructObjectPropertyString "step" val

data DOMHTMLInputElementStepPropertyInfo
instance AttrInfo DOMHTMLInputElementStepPropertyInfo where
    type AttrAllowedOps DOMHTMLInputElementStepPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLInputElementStepPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLInputElementStepPropertyInfo = DOMHTMLInputElementK
    type AttrGetType DOMHTMLInputElementStepPropertyInfo = T.Text
    type AttrLabel DOMHTMLInputElementStepPropertyInfo = "DOMHTMLInputElement::step"
    attrGet _ = getDOMHTMLInputElementStep
    attrSet _ = setDOMHTMLInputElementStep
    attrConstruct _ = constructDOMHTMLInputElementStep

-- VVV Prop "type"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLInputElementType :: (MonadIO m, DOMHTMLInputElementK o) => o -> m T.Text
getDOMHTMLInputElementType obj = liftIO $ getObjectPropertyString obj "type"

setDOMHTMLInputElementType :: (MonadIO m, DOMHTMLInputElementK o) => o -> T.Text -> m ()
setDOMHTMLInputElementType obj val = liftIO $ setObjectPropertyString obj "type" val

constructDOMHTMLInputElementType :: T.Text -> IO ([Char], GValue)
constructDOMHTMLInputElementType val = constructObjectPropertyString "type" val

data DOMHTMLInputElementTypePropertyInfo
instance AttrInfo DOMHTMLInputElementTypePropertyInfo where
    type AttrAllowedOps DOMHTMLInputElementTypePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLInputElementTypePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLInputElementTypePropertyInfo = DOMHTMLInputElementK
    type AttrGetType DOMHTMLInputElementTypePropertyInfo = T.Text
    type AttrLabel DOMHTMLInputElementTypePropertyInfo = "DOMHTMLInputElement::type"
    attrGet _ = getDOMHTMLInputElementType
    attrSet _ = setDOMHTMLInputElementType
    attrConstruct _ = constructDOMHTMLInputElementType

-- VVV Prop "use-map"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLInputElementUseMap :: (MonadIO m, DOMHTMLInputElementK o) => o -> m T.Text
getDOMHTMLInputElementUseMap obj = liftIO $ getObjectPropertyString obj "use-map"

setDOMHTMLInputElementUseMap :: (MonadIO m, DOMHTMLInputElementK o) => o -> T.Text -> m ()
setDOMHTMLInputElementUseMap obj val = liftIO $ setObjectPropertyString obj "use-map" val

constructDOMHTMLInputElementUseMap :: T.Text -> IO ([Char], GValue)
constructDOMHTMLInputElementUseMap val = constructObjectPropertyString "use-map" val

data DOMHTMLInputElementUseMapPropertyInfo
instance AttrInfo DOMHTMLInputElementUseMapPropertyInfo where
    type AttrAllowedOps DOMHTMLInputElementUseMapPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLInputElementUseMapPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLInputElementUseMapPropertyInfo = DOMHTMLInputElementK
    type AttrGetType DOMHTMLInputElementUseMapPropertyInfo = T.Text
    type AttrLabel DOMHTMLInputElementUseMapPropertyInfo = "DOMHTMLInputElement::use-map"
    attrGet _ = getDOMHTMLInputElementUseMap
    attrSet _ = setDOMHTMLInputElementUseMap
    attrConstruct _ = constructDOMHTMLInputElementUseMap

-- VVV Prop "validation-message"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable]

getDOMHTMLInputElementValidationMessage :: (MonadIO m, DOMHTMLInputElementK o) => o -> m T.Text
getDOMHTMLInputElementValidationMessage obj = liftIO $ getObjectPropertyString obj "validation-message"

data DOMHTMLInputElementValidationMessagePropertyInfo
instance AttrInfo DOMHTMLInputElementValidationMessagePropertyInfo where
    type AttrAllowedOps DOMHTMLInputElementValidationMessagePropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLInputElementValidationMessagePropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLInputElementValidationMessagePropertyInfo = DOMHTMLInputElementK
    type AttrGetType DOMHTMLInputElementValidationMessagePropertyInfo = T.Text
    type AttrLabel DOMHTMLInputElementValidationMessagePropertyInfo = "DOMHTMLInputElement::validation-message"
    attrGet _ = getDOMHTMLInputElementValidationMessage
    attrSet _ = undefined
    attrConstruct _ = undefined

-- VVV Prop "value"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLInputElementValue :: (MonadIO m, DOMHTMLInputElementK o) => o -> m T.Text
getDOMHTMLInputElementValue obj = liftIO $ getObjectPropertyString obj "value"

setDOMHTMLInputElementValue :: (MonadIO m, DOMHTMLInputElementK o) => o -> T.Text -> m ()
setDOMHTMLInputElementValue obj val = liftIO $ setObjectPropertyString obj "value" val

constructDOMHTMLInputElementValue :: T.Text -> IO ([Char], GValue)
constructDOMHTMLInputElementValue val = constructObjectPropertyString "value" val

data DOMHTMLInputElementValuePropertyInfo
instance AttrInfo DOMHTMLInputElementValuePropertyInfo where
    type AttrAllowedOps DOMHTMLInputElementValuePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLInputElementValuePropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLInputElementValuePropertyInfo = DOMHTMLInputElementK
    type AttrGetType DOMHTMLInputElementValuePropertyInfo = T.Text
    type AttrLabel DOMHTMLInputElementValuePropertyInfo = "DOMHTMLInputElement::value"
    attrGet _ = getDOMHTMLInputElementValue
    attrSet _ = setDOMHTMLInputElementValue
    attrConstruct _ = constructDOMHTMLInputElementValue

-- VVV Prop "value-as-number"
   -- Type: TBasicType TDouble
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLInputElementValueAsNumber :: (MonadIO m, DOMHTMLInputElementK o) => o -> m Double
getDOMHTMLInputElementValueAsNumber obj = liftIO $ getObjectPropertyDouble obj "value-as-number"

setDOMHTMLInputElementValueAsNumber :: (MonadIO m, DOMHTMLInputElementK o) => o -> Double -> m ()
setDOMHTMLInputElementValueAsNumber obj val = liftIO $ setObjectPropertyDouble obj "value-as-number" val

constructDOMHTMLInputElementValueAsNumber :: Double -> IO ([Char], GValue)
constructDOMHTMLInputElementValueAsNumber val = constructObjectPropertyDouble "value-as-number" val

data DOMHTMLInputElementValueAsNumberPropertyInfo
instance AttrInfo DOMHTMLInputElementValueAsNumberPropertyInfo where
    type AttrAllowedOps DOMHTMLInputElementValueAsNumberPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLInputElementValueAsNumberPropertyInfo = (~) Double
    type AttrBaseTypeConstraint DOMHTMLInputElementValueAsNumberPropertyInfo = DOMHTMLInputElementK
    type AttrGetType DOMHTMLInputElementValueAsNumberPropertyInfo = Double
    type AttrLabel DOMHTMLInputElementValueAsNumberPropertyInfo = "DOMHTMLInputElement::value-as-number"
    attrGet _ = getDOMHTMLInputElementValueAsNumber
    attrSet _ = setDOMHTMLInputElementValueAsNumber
    attrConstruct _ = constructDOMHTMLInputElementValueAsNumber

-- VVV Prop "width"
   -- Type: TBasicType TUInt64
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLInputElementWidth :: (MonadIO m, DOMHTMLInputElementK o) => o -> m Word64
getDOMHTMLInputElementWidth obj = liftIO $ getObjectPropertyUInt64 obj "width"

setDOMHTMLInputElementWidth :: (MonadIO m, DOMHTMLInputElementK o) => o -> Word64 -> m ()
setDOMHTMLInputElementWidth obj val = liftIO $ setObjectPropertyUInt64 obj "width" val

constructDOMHTMLInputElementWidth :: Word64 -> IO ([Char], GValue)
constructDOMHTMLInputElementWidth val = constructObjectPropertyUInt64 "width" val

data DOMHTMLInputElementWidthPropertyInfo
instance AttrInfo DOMHTMLInputElementWidthPropertyInfo where
    type AttrAllowedOps DOMHTMLInputElementWidthPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLInputElementWidthPropertyInfo = (~) Word64
    type AttrBaseTypeConstraint DOMHTMLInputElementWidthPropertyInfo = DOMHTMLInputElementK
    type AttrGetType DOMHTMLInputElementWidthPropertyInfo = Word64
    type AttrLabel DOMHTMLInputElementWidthPropertyInfo = "DOMHTMLInputElement::width"
    attrGet _ = getDOMHTMLInputElementWidth
    attrSet _ = setDOMHTMLInputElementWidth
    attrConstruct _ = constructDOMHTMLInputElementWidth

-- VVV Prop "will-validate"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable]

getDOMHTMLInputElementWillValidate :: (MonadIO m, DOMHTMLInputElementK o) => o -> m Bool
getDOMHTMLInputElementWillValidate obj = liftIO $ getObjectPropertyBool obj "will-validate"

data DOMHTMLInputElementWillValidatePropertyInfo
instance AttrInfo DOMHTMLInputElementWillValidatePropertyInfo where
    type AttrAllowedOps DOMHTMLInputElementWillValidatePropertyInfo = '[ 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLInputElementWillValidatePropertyInfo = (~) ()
    type AttrBaseTypeConstraint DOMHTMLInputElementWillValidatePropertyInfo = DOMHTMLInputElementK
    type AttrGetType DOMHTMLInputElementWillValidatePropertyInfo = Bool
    type AttrLabel DOMHTMLInputElementWillValidatePropertyInfo = "DOMHTMLInputElement::will-validate"
    attrGet _ = getDOMHTMLInputElementWillValidate
    attrSet _ = undefined
    attrConstruct _ = undefined

type instance AttributeList DOMHTMLInputElement = DOMHTMLInputElementAttributeList
type DOMHTMLInputElementAttributeList = ('[ '("accept", DOMHTMLInputElementAcceptPropertyInfo), '("access-key", DOMHTMLElementAccessKeyPropertyInfo), '("align", DOMHTMLInputElementAlignPropertyInfo), '("alt", DOMHTMLInputElementAltPropertyInfo), '("attributes", DOMElementAttributesPropertyInfo), '("autocapitalize", DOMHTMLInputElementAutocapitalizePropertyInfo), '("autocomplete", DOMHTMLInputElementAutocompletePropertyInfo), '("autocorrect", DOMHTMLInputElementAutocorrectPropertyInfo), '("autofocus", DOMHTMLInputElementAutofocusPropertyInfo), '("base-uri", DOMNodeBaseUriPropertyInfo), '("capture", DOMHTMLInputElementCapturePropertyInfo), '("checked", DOMHTMLInputElementCheckedPropertyInfo), '("child-element-count", DOMElementChildElementCountPropertyInfo), '("child-nodes", DOMNodeChildNodesPropertyInfo), '("children", DOMHTMLElementChildrenPropertyInfo), '("class-name", DOMElementClassNamePropertyInfo), '("client-height", DOMElementClientHeightPropertyInfo), '("client-left", DOMElementClientLeftPropertyInfo), '("client-top", DOMElementClientTopPropertyInfo), '("client-width", DOMElementClientWidthPropertyInfo), '("content-editable", DOMHTMLElementContentEditablePropertyInfo), '("core-object", DOMObjectCoreObjectPropertyInfo), '("default-checked", DOMHTMLInputElementDefaultCheckedPropertyInfo), '("default-value", DOMHTMLInputElementDefaultValuePropertyInfo), '("dir", DOMHTMLElementDirPropertyInfo), '("dir-name", DOMHTMLInputElementDirNamePropertyInfo), '("disabled", DOMHTMLInputElementDisabledPropertyInfo), '("draggable", DOMHTMLElementDraggablePropertyInfo), '("files", DOMHTMLInputElementFilesPropertyInfo), '("first-child", DOMNodeFirstChildPropertyInfo), '("first-element-child", DOMElementFirstElementChildPropertyInfo), '("form", DOMHTMLInputElementFormPropertyInfo), '("form-action", DOMHTMLInputElementFormActionPropertyInfo), '("form-enctype", DOMHTMLInputElementFormEnctypePropertyInfo), '("form-method", DOMHTMLInputElementFormMethodPropertyInfo), '("form-no-validate", DOMHTMLInputElementFormNoValidatePropertyInfo), '("form-target", DOMHTMLInputElementFormTargetPropertyInfo), '("height", DOMHTMLInputElementHeightPropertyInfo), '("hidden", DOMHTMLElementHiddenPropertyInfo), '("id", DOMElementIdPropertyInfo), '("incremental", DOMHTMLInputElementIncrementalPropertyInfo), '("indeterminate", DOMHTMLInputElementIndeterminatePropertyInfo), '("inner-html", DOMElementInnerHtmlPropertyInfo), '("inner-text", DOMHTMLElementInnerTextPropertyInfo), '("is-content-editable", DOMHTMLElementIsContentEditablePropertyInfo), '("labels", DOMHTMLInputElementLabelsPropertyInfo), '("lang", DOMHTMLElementLangPropertyInfo), '("last-child", DOMNodeLastChildPropertyInfo), '("last-element-child", DOMElementLastElementChildPropertyInfo), '("list", DOMHTMLInputElementListPropertyInfo), '("local-name", DOMNodeLocalNamePropertyInfo), '("max", DOMHTMLInputElementMaxPropertyInfo), '("max-length", DOMHTMLInputElementMaxLengthPropertyInfo), '("min", DOMHTMLInputElementMinPropertyInfo), '("multiple", DOMHTMLInputElementMultiplePropertyInfo), '("name", DOMHTMLInputElementNamePropertyInfo), '("namespace-uri", DOMNodeNamespaceUriPropertyInfo), '("next-element-sibling", DOMElementNextElementSiblingPropertyInfo), '("next-sibling", DOMNodeNextSiblingPropertyInfo), '("node-name", DOMNodeNodeNamePropertyInfo), '("node-type", DOMNodeNodeTypePropertyInfo), '("node-value", DOMNodeNodeValuePropertyInfo), '("offset-height", DOMElementOffsetHeightPropertyInfo), '("offset-left", DOMElementOffsetLeftPropertyInfo), '("offset-parent", DOMElementOffsetParentPropertyInfo), '("offset-top", DOMElementOffsetTopPropertyInfo), '("offset-width", DOMElementOffsetWidthPropertyInfo), '("outer-html", DOMElementOuterHtmlPropertyInfo), '("outer-text", DOMHTMLElementOuterTextPropertyInfo), '("owner-document", DOMNodeOwnerDocumentPropertyInfo), '("parent-element", DOMNodeParentElementPropertyInfo), '("parent-node", DOMNodeParentNodePropertyInfo), '("pattern", DOMHTMLInputElementPatternPropertyInfo), '("placeholder", DOMHTMLInputElementPlaceholderPropertyInfo), '("prefix", DOMNodePrefixPropertyInfo), '("previous-element-sibling", DOMElementPreviousElementSiblingPropertyInfo), '("previous-sibling", DOMNodePreviousSiblingPropertyInfo), '("read-only", DOMHTMLInputElementReadOnlyPropertyInfo), '("required", DOMHTMLInputElementRequiredPropertyInfo), '("scroll-height", DOMElementScrollHeightPropertyInfo), '("scroll-left", DOMElementScrollLeftPropertyInfo), '("scroll-top", DOMElementScrollTopPropertyInfo), '("scroll-width", DOMElementScrollWidthPropertyInfo), '("size", DOMHTMLInputElementSizePropertyInfo), '("spellcheck", DOMHTMLElementSpellcheckPropertyInfo), '("src", DOMHTMLInputElementSrcPropertyInfo), '("step", DOMHTMLInputElementStepPropertyInfo), '("style", DOMElementStylePropertyInfo), '("tab-index", DOMHTMLElementTabIndexPropertyInfo), '("tag-name", DOMElementTagNamePropertyInfo), '("text-content", DOMNodeTextContentPropertyInfo), '("title", DOMHTMLElementTitlePropertyInfo), '("translate", DOMHTMLElementTranslatePropertyInfo), '("type", DOMHTMLInputElementTypePropertyInfo), '("use-map", DOMHTMLInputElementUseMapPropertyInfo), '("validation-message", DOMHTMLInputElementValidationMessagePropertyInfo), '("value", DOMHTMLInputElementValuePropertyInfo), '("value-as-number", DOMHTMLInputElementValueAsNumberPropertyInfo), '("webkit-region-overset", DOMElementWebkitRegionOversetPropertyInfo), '("webkitdropzone", DOMHTMLElementWebkitdropzonePropertyInfo), '("width", DOMHTMLInputElementWidthPropertyInfo), '("will-validate", DOMHTMLInputElementWillValidatePropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMHTMLInputElement = DOMHTMLInputElementSignalList
type DOMHTMLInputElementSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMHTMLInputElement::get_accept
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_input_element_get_accept" webkit_dom_html_input_element_get_accept :: 
    Ptr DOMHTMLInputElement ->              -- _obj : TInterface "WebKit2WebExtension" "DOMHTMLInputElement"
    IO CString


dOMHTMLInputElementGetAccept ::
    (MonadIO m, DOMHTMLInputElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLInputElementGetAccept _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_input_element_get_accept _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_input_element_get_accept" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLInputElement::get_align
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_input_element_get_align" webkit_dom_html_input_element_get_align :: 
    Ptr DOMHTMLInputElement ->              -- _obj : TInterface "WebKit2WebExtension" "DOMHTMLInputElement"
    IO CString


dOMHTMLInputElementGetAlign ::
    (MonadIO m, DOMHTMLInputElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLInputElementGetAlign _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_input_element_get_align _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_input_element_get_align" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLInputElement::get_alt
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_input_element_get_alt" webkit_dom_html_input_element_get_alt :: 
    Ptr DOMHTMLInputElement ->              -- _obj : TInterface "WebKit2WebExtension" "DOMHTMLInputElement"
    IO CString


dOMHTMLInputElementGetAlt ::
    (MonadIO m, DOMHTMLInputElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLInputElementGetAlt _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_input_element_get_alt _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_input_element_get_alt" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLInputElement::get_autofocus
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_input_element_get_autofocus" webkit_dom_html_input_element_get_autofocus :: 
    Ptr DOMHTMLInputElement ->              -- _obj : TInterface "WebKit2WebExtension" "DOMHTMLInputElement"
    IO CInt


dOMHTMLInputElementGetAutofocus ::
    (MonadIO m, DOMHTMLInputElementK a) =>
    a ->                                    -- _obj
    m Bool
dOMHTMLInputElementGetAutofocus _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_input_element_get_autofocus _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLInputElement::get_capture
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_input_element_get_capture" webkit_dom_html_input_element_get_capture :: 
    Ptr DOMHTMLInputElement ->              -- _obj : TInterface "WebKit2WebExtension" "DOMHTMLInputElement"
    IO CInt


dOMHTMLInputElementGetCapture ::
    (MonadIO m, DOMHTMLInputElementK a) =>
    a ->                                    -- _obj
    m Bool
dOMHTMLInputElementGetCapture _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_input_element_get_capture _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLInputElement::get_checked
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_input_element_get_checked" webkit_dom_html_input_element_get_checked :: 
    Ptr DOMHTMLInputElement ->              -- _obj : TInterface "WebKit2WebExtension" "DOMHTMLInputElement"
    IO CInt


dOMHTMLInputElementGetChecked ::
    (MonadIO m, DOMHTMLInputElementK a) =>
    a ->                                    -- _obj
    m Bool
dOMHTMLInputElementGetChecked _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_input_element_get_checked _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLInputElement::get_default_checked
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_input_element_get_default_checked" webkit_dom_html_input_element_get_default_checked :: 
    Ptr DOMHTMLInputElement ->              -- _obj : TInterface "WebKit2WebExtension" "DOMHTMLInputElement"
    IO CInt


dOMHTMLInputElementGetDefaultChecked ::
    (MonadIO m, DOMHTMLInputElementK a) =>
    a ->                                    -- _obj
    m Bool
dOMHTMLInputElementGetDefaultChecked _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_input_element_get_default_checked _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLInputElement::get_default_value
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_input_element_get_default_value" webkit_dom_html_input_element_get_default_value :: 
    Ptr DOMHTMLInputElement ->              -- _obj : TInterface "WebKit2WebExtension" "DOMHTMLInputElement"
    IO CString


dOMHTMLInputElementGetDefaultValue ::
    (MonadIO m, DOMHTMLInputElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLInputElementGetDefaultValue _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_input_element_get_default_value _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_input_element_get_default_value" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLInputElement::get_disabled
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_input_element_get_disabled" webkit_dom_html_input_element_get_disabled :: 
    Ptr DOMHTMLInputElement ->              -- _obj : TInterface "WebKit2WebExtension" "DOMHTMLInputElement"
    IO CInt


dOMHTMLInputElementGetDisabled ::
    (MonadIO m, DOMHTMLInputElementK a) =>
    a ->                                    -- _obj
    m Bool
dOMHTMLInputElementGetDisabled _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_input_element_get_disabled _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLInputElement::get_files
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit2WebExtension" "DOMFileList"
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_input_element_get_files" webkit_dom_html_input_element_get_files :: 
    Ptr DOMHTMLInputElement ->              -- _obj : TInterface "WebKit2WebExtension" "DOMHTMLInputElement"
    IO (Ptr DOMFileList)


dOMHTMLInputElementGetFiles ::
    (MonadIO m, DOMHTMLInputElementK a) =>
    a ->                                    -- _obj
    m DOMFileList
dOMHTMLInputElementGetFiles _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_input_element_get_files _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_input_element_get_files" result
    result' <- (wrapObject DOMFileList) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLInputElement::get_form
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit2WebExtension" "DOMHTMLFormElement"
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_input_element_get_form" webkit_dom_html_input_element_get_form :: 
    Ptr DOMHTMLInputElement ->              -- _obj : TInterface "WebKit2WebExtension" "DOMHTMLInputElement"
    IO (Ptr DOMHTMLFormElement)


dOMHTMLInputElementGetForm ::
    (MonadIO m, DOMHTMLInputElementK a) =>
    a ->                                    -- _obj
    m DOMHTMLFormElement
dOMHTMLInputElementGetForm _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_input_element_get_form _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_input_element_get_form" result
    result' <- (newObject DOMHTMLFormElement) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLInputElement::get_height
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUInt64
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_input_element_get_height" webkit_dom_html_input_element_get_height :: 
    Ptr DOMHTMLInputElement ->              -- _obj : TInterface "WebKit2WebExtension" "DOMHTMLInputElement"
    IO Word64


dOMHTMLInputElementGetHeight ::
    (MonadIO m, DOMHTMLInputElementK a) =>
    a ->                                    -- _obj
    m Word64
dOMHTMLInputElementGetHeight _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_input_element_get_height _obj'
    touchManagedPtr _obj
    return result

-- method DOMHTMLInputElement::get_indeterminate
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_input_element_get_indeterminate" webkit_dom_html_input_element_get_indeterminate :: 
    Ptr DOMHTMLInputElement ->              -- _obj : TInterface "WebKit2WebExtension" "DOMHTMLInputElement"
    IO CInt


dOMHTMLInputElementGetIndeterminate ::
    (MonadIO m, DOMHTMLInputElementK a) =>
    a ->                                    -- _obj
    m Bool
dOMHTMLInputElementGetIndeterminate _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_input_element_get_indeterminate _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLInputElement::get_input_type
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_input_element_get_input_type" webkit_dom_html_input_element_get_input_type :: 
    Ptr DOMHTMLInputElement ->              -- _obj : TInterface "WebKit2WebExtension" "DOMHTMLInputElement"
    IO CString


dOMHTMLInputElementGetInputType ::
    (MonadIO m, DOMHTMLInputElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLInputElementGetInputType _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_input_element_get_input_type _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_input_element_get_input_type" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLInputElement::get_max_length
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TInt64
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_input_element_get_max_length" webkit_dom_html_input_element_get_max_length :: 
    Ptr DOMHTMLInputElement ->              -- _obj : TInterface "WebKit2WebExtension" "DOMHTMLInputElement"
    IO Int64


dOMHTMLInputElementGetMaxLength ::
    (MonadIO m, DOMHTMLInputElementK a) =>
    a ->                                    -- _obj
    m Int64
dOMHTMLInputElementGetMaxLength _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_input_element_get_max_length _obj'
    touchManagedPtr _obj
    return result

-- method DOMHTMLInputElement::get_multiple
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_input_element_get_multiple" webkit_dom_html_input_element_get_multiple :: 
    Ptr DOMHTMLInputElement ->              -- _obj : TInterface "WebKit2WebExtension" "DOMHTMLInputElement"
    IO CInt


dOMHTMLInputElementGetMultiple ::
    (MonadIO m, DOMHTMLInputElementK a) =>
    a ->                                    -- _obj
    m Bool
dOMHTMLInputElementGetMultiple _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_input_element_get_multiple _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLInputElement::get_name
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_input_element_get_name" webkit_dom_html_input_element_get_name :: 
    Ptr DOMHTMLInputElement ->              -- _obj : TInterface "WebKit2WebExtension" "DOMHTMLInputElement"
    IO CString


dOMHTMLInputElementGetName ::
    (MonadIO m, DOMHTMLInputElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLInputElementGetName _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_input_element_get_name _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_input_element_get_name" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLInputElement::get_size
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUInt64
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_input_element_get_size" webkit_dom_html_input_element_get_size :: 
    Ptr DOMHTMLInputElement ->              -- _obj : TInterface "WebKit2WebExtension" "DOMHTMLInputElement"
    IO Word64


dOMHTMLInputElementGetSize ::
    (MonadIO m, DOMHTMLInputElementK a) =>
    a ->                                    -- _obj
    m Word64
dOMHTMLInputElementGetSize _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_input_element_get_size _obj'
    touchManagedPtr _obj
    return result

-- method DOMHTMLInputElement::get_src
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_input_element_get_src" webkit_dom_html_input_element_get_src :: 
    Ptr DOMHTMLInputElement ->              -- _obj : TInterface "WebKit2WebExtension" "DOMHTMLInputElement"
    IO CString


dOMHTMLInputElementGetSrc ::
    (MonadIO m, DOMHTMLInputElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLInputElementGetSrc _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_input_element_get_src _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_input_element_get_src" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLInputElement::get_use_map
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_input_element_get_use_map" webkit_dom_html_input_element_get_use_map :: 
    Ptr DOMHTMLInputElement ->              -- _obj : TInterface "WebKit2WebExtension" "DOMHTMLInputElement"
    IO CString


dOMHTMLInputElementGetUseMap ::
    (MonadIO m, DOMHTMLInputElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLInputElementGetUseMap _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_input_element_get_use_map _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_input_element_get_use_map" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLInputElement::get_value
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUTF8
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_input_element_get_value" webkit_dom_html_input_element_get_value :: 
    Ptr DOMHTMLInputElement ->              -- _obj : TInterface "WebKit2WebExtension" "DOMHTMLInputElement"
    IO CString


dOMHTMLInputElementGetValue ::
    (MonadIO m, DOMHTMLInputElementK a) =>
    a ->                                    -- _obj
    m T.Text
dOMHTMLInputElementGetValue _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_input_element_get_value _obj'
    checkUnexpectedReturnNULL "webkit_dom_html_input_element_get_value" result
    result' <- cstringToText result
    freeMem result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLInputElement::get_width
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TUInt64
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_input_element_get_width" webkit_dom_html_input_element_get_width :: 
    Ptr DOMHTMLInputElement ->              -- _obj : TInterface "WebKit2WebExtension" "DOMHTMLInputElement"
    IO Word64


dOMHTMLInputElementGetWidth ::
    (MonadIO m, DOMHTMLInputElementK a) =>
    a ->                                    -- _obj
    m Word64
dOMHTMLInputElementGetWidth _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_input_element_get_width _obj'
    touchManagedPtr _obj
    return result

-- method DOMHTMLInputElement::get_will_validate
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_input_element_get_will_validate" webkit_dom_html_input_element_get_will_validate :: 
    Ptr DOMHTMLInputElement ->              -- _obj : TInterface "WebKit2WebExtension" "DOMHTMLInputElement"
    IO CInt


dOMHTMLInputElementGetWillValidate ::
    (MonadIO m, DOMHTMLInputElementK a) =>
    a ->                                    -- _obj
    m Bool
dOMHTMLInputElementGetWillValidate _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_input_element_get_will_validate _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLInputElement::is_edited
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TBoolean
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_input_element_is_edited" webkit_dom_html_input_element_is_edited :: 
    Ptr DOMHTMLInputElement ->              -- _obj : TInterface "WebKit2WebExtension" "DOMHTMLInputElement"
    IO CInt


dOMHTMLInputElementIsEdited ::
    (MonadIO m, DOMHTMLInputElementK a) =>
    a ->                                    -- _obj
    m Bool
dOMHTMLInputElementIsEdited _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_dom_html_input_element_is_edited _obj'
    let result' = (/= 0) result
    touchManagedPtr _obj
    return result'

-- method DOMHTMLInputElement::select
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_input_element_select" webkit_dom_html_input_element_select :: 
    Ptr DOMHTMLInputElement ->              -- _obj : TInterface "WebKit2WebExtension" "DOMHTMLInputElement"
    IO ()


dOMHTMLInputElementSelect ::
    (MonadIO m, DOMHTMLInputElementK a) =>
    a ->                                    -- _obj
    m ()
dOMHTMLInputElementSelect _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    webkit_dom_html_input_element_select _obj'
    touchManagedPtr _obj
    return ()

-- method DOMHTMLInputElement::set_accept
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_input_element_set_accept" webkit_dom_html_input_element_set_accept :: 
    Ptr DOMHTMLInputElement ->              -- _obj : TInterface "WebKit2WebExtension" "DOMHTMLInputElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLInputElementSetAccept ::
    (MonadIO m, DOMHTMLInputElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLInputElementSetAccept _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_input_element_set_accept _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLInputElement::set_align
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_input_element_set_align" webkit_dom_html_input_element_set_align :: 
    Ptr DOMHTMLInputElement ->              -- _obj : TInterface "WebKit2WebExtension" "DOMHTMLInputElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLInputElementSetAlign ::
    (MonadIO m, DOMHTMLInputElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLInputElementSetAlign _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_input_element_set_align _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLInputElement::set_alt
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_input_element_set_alt" webkit_dom_html_input_element_set_alt :: 
    Ptr DOMHTMLInputElement ->              -- _obj : TInterface "WebKit2WebExtension" "DOMHTMLInputElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLInputElementSetAlt ::
    (MonadIO m, DOMHTMLInputElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLInputElementSetAlt _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_input_element_set_alt _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLInputElement::set_autofocus
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_input_element_set_autofocus" webkit_dom_html_input_element_set_autofocus :: 
    Ptr DOMHTMLInputElement ->              -- _obj : TInterface "WebKit2WebExtension" "DOMHTMLInputElement"
    CInt ->                                 -- value : TBasicType TBoolean
    IO ()


dOMHTMLInputElementSetAutofocus ::
    (MonadIO m, DOMHTMLInputElementK a) =>
    a ->                                    -- _obj
    Bool ->                                 -- value
    m ()
dOMHTMLInputElementSetAutofocus _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let value' = (fromIntegral . fromEnum) value
    webkit_dom_html_input_element_set_autofocus _obj' value'
    touchManagedPtr _obj
    return ()

-- method DOMHTMLInputElement::set_checked
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_input_element_set_checked" webkit_dom_html_input_element_set_checked :: 
    Ptr DOMHTMLInputElement ->              -- _obj : TInterface "WebKit2WebExtension" "DOMHTMLInputElement"
    CInt ->                                 -- value : TBasicType TBoolean
    IO ()


dOMHTMLInputElementSetChecked ::
    (MonadIO m, DOMHTMLInputElementK a) =>
    a ->                                    -- _obj
    Bool ->                                 -- value
    m ()
dOMHTMLInputElementSetChecked _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let value' = (fromIntegral . fromEnum) value
    webkit_dom_html_input_element_set_checked _obj' value'
    touchManagedPtr _obj
    return ()

-- method DOMHTMLInputElement::set_default_value
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_input_element_set_default_value" webkit_dom_html_input_element_set_default_value :: 
    Ptr DOMHTMLInputElement ->              -- _obj : TInterface "WebKit2WebExtension" "DOMHTMLInputElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLInputElementSetDefaultValue ::
    (MonadIO m, DOMHTMLInputElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLInputElementSetDefaultValue _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_input_element_set_default_value _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLInputElement::set_disabled
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_input_element_set_disabled" webkit_dom_html_input_element_set_disabled :: 
    Ptr DOMHTMLInputElement ->              -- _obj : TInterface "WebKit2WebExtension" "DOMHTMLInputElement"
    CInt ->                                 -- value : TBasicType TBoolean
    IO ()


dOMHTMLInputElementSetDisabled ::
    (MonadIO m, DOMHTMLInputElementK a) =>
    a ->                                    -- _obj
    Bool ->                                 -- value
    m ()
dOMHTMLInputElementSetDisabled _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let value' = (fromIntegral . fromEnum) value
    webkit_dom_html_input_element_set_disabled _obj' value'
    touchManagedPtr _obj
    return ()

-- method DOMHTMLInputElement::set_files
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TInterface "WebKit2WebExtension" "DOMFileList", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TInterface "WebKit2WebExtension" "DOMFileList", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_input_element_set_files" webkit_dom_html_input_element_set_files :: 
    Ptr DOMHTMLInputElement ->              -- _obj : TInterface "WebKit2WebExtension" "DOMHTMLInputElement"
    Ptr DOMFileList ->                      -- value : TInterface "WebKit2WebExtension" "DOMFileList"
    IO ()


dOMHTMLInputElementSetFiles ::
    (MonadIO m, DOMHTMLInputElementK a, DOMFileListK b) =>
    a ->                                    -- _obj
    b ->                                    -- value
    m ()
dOMHTMLInputElementSetFiles _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let value' = unsafeManagedPtrCastPtr value
    webkit_dom_html_input_element_set_files _obj' value'
    touchManagedPtr _obj
    touchManagedPtr value
    return ()

-- method DOMHTMLInputElement::set_height
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_input_element_set_height" webkit_dom_html_input_element_set_height :: 
    Ptr DOMHTMLInputElement ->              -- _obj : TInterface "WebKit2WebExtension" "DOMHTMLInputElement"
    Word64 ->                               -- value : TBasicType TUInt64
    IO ()


dOMHTMLInputElementSetHeight ::
    (MonadIO m, DOMHTMLInputElementK a) =>
    a ->                                    -- _obj
    Word64 ->                               -- value
    m ()
dOMHTMLInputElementSetHeight _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    webkit_dom_html_input_element_set_height _obj' value
    touchManagedPtr _obj
    return ()

-- method DOMHTMLInputElement::set_indeterminate
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_input_element_set_indeterminate" webkit_dom_html_input_element_set_indeterminate :: 
    Ptr DOMHTMLInputElement ->              -- _obj : TInterface "WebKit2WebExtension" "DOMHTMLInputElement"
    CInt ->                                 -- value : TBasicType TBoolean
    IO ()


dOMHTMLInputElementSetIndeterminate ::
    (MonadIO m, DOMHTMLInputElementK a) =>
    a ->                                    -- _obj
    Bool ->                                 -- value
    m ()
dOMHTMLInputElementSetIndeterminate _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let value' = (fromIntegral . fromEnum) value
    webkit_dom_html_input_element_set_indeterminate _obj' value'
    touchManagedPtr _obj
    return ()

-- method DOMHTMLInputElement::set_input_type
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_input_element_set_input_type" webkit_dom_html_input_element_set_input_type :: 
    Ptr DOMHTMLInputElement ->              -- _obj : TInterface "WebKit2WebExtension" "DOMHTMLInputElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLInputElementSetInputType ::
    (MonadIO m, DOMHTMLInputElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLInputElementSetInputType _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_input_element_set_input_type _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLInputElement::set_max_length
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_html_input_element_set_max_length" webkit_dom_html_input_element_set_max_length :: 
    Ptr DOMHTMLInputElement ->              -- _obj : TInterface "WebKit2WebExtension" "DOMHTMLInputElement"
    Int64 ->                                -- value : TBasicType TInt64
    Ptr (Ptr GError) ->                     -- error
    IO ()


dOMHTMLInputElementSetMaxLength ::
    (MonadIO m, DOMHTMLInputElementK a) =>
    a ->                                    -- _obj
    Int64 ->                                -- value
    m ()
dOMHTMLInputElementSetMaxLength _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    onException (do
        propagateGError $ webkit_dom_html_input_element_set_max_length _obj' value
        touchManagedPtr _obj
        return ()
     ) (do
        return ()
     )

-- method DOMHTMLInputElement::set_multiple
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_input_element_set_multiple" webkit_dom_html_input_element_set_multiple :: 
    Ptr DOMHTMLInputElement ->              -- _obj : TInterface "WebKit2WebExtension" "DOMHTMLInputElement"
    CInt ->                                 -- value : TBasicType TBoolean
    IO ()


dOMHTMLInputElementSetMultiple ::
    (MonadIO m, DOMHTMLInputElementK a) =>
    a ->                                    -- _obj
    Bool ->                                 -- value
    m ()
dOMHTMLInputElementSetMultiple _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let value' = (fromIntegral . fromEnum) value
    webkit_dom_html_input_element_set_multiple _obj' value'
    touchManagedPtr _obj
    return ()

-- method DOMHTMLInputElement::set_name
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_input_element_set_name" webkit_dom_html_input_element_set_name :: 
    Ptr DOMHTMLInputElement ->              -- _obj : TInterface "WebKit2WebExtension" "DOMHTMLInputElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLInputElementSetName ::
    (MonadIO m, DOMHTMLInputElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLInputElementSetName _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_input_element_set_name _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLInputElement::set_read_only
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_input_element_set_read_only" webkit_dom_html_input_element_set_read_only :: 
    Ptr DOMHTMLInputElement ->              -- _obj : TInterface "WebKit2WebExtension" "DOMHTMLInputElement"
    CInt ->                                 -- value : TBasicType TBoolean
    IO ()


dOMHTMLInputElementSetReadOnly ::
    (MonadIO m, DOMHTMLInputElementK a) =>
    a ->                                    -- _obj
    Bool ->                                 -- value
    m ()
dOMHTMLInputElementSetReadOnly _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    let value' = (fromIntegral . fromEnum) value
    webkit_dom_html_input_element_set_read_only _obj' value'
    touchManagedPtr _obj
    return ()

-- method DOMHTMLInputElement::set_size
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : True
-- Skip return : False

foreign import ccall "webkit_dom_html_input_element_set_size" webkit_dom_html_input_element_set_size :: 
    Ptr DOMHTMLInputElement ->              -- _obj : TInterface "WebKit2WebExtension" "DOMHTMLInputElement"
    Word64 ->                               -- value : TBasicType TUInt64
    Ptr (Ptr GError) ->                     -- error
    IO ()


dOMHTMLInputElementSetSize ::
    (MonadIO m, DOMHTMLInputElementK a) =>
    a ->                                    -- _obj
    Word64 ->                               -- value
    m ()
dOMHTMLInputElementSetSize _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    onException (do
        propagateGError $ webkit_dom_html_input_element_set_size _obj' value
        touchManagedPtr _obj
        return ()
     ) (do
        return ()
     )

-- method DOMHTMLInputElement::set_src
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_input_element_set_src" webkit_dom_html_input_element_set_src :: 
    Ptr DOMHTMLInputElement ->              -- _obj : TInterface "WebKit2WebExtension" "DOMHTMLInputElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLInputElementSetSrc ::
    (MonadIO m, DOMHTMLInputElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLInputElementSetSrc _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_input_element_set_src _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLInputElement::set_use_map
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_input_element_set_use_map" webkit_dom_html_input_element_set_use_map :: 
    Ptr DOMHTMLInputElement ->              -- _obj : TInterface "WebKit2WebExtension" "DOMHTMLInputElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLInputElementSetUseMap ::
    (MonadIO m, DOMHTMLInputElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLInputElementSetUseMap _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_input_element_set_use_map _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLInputElement::set_value
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUTF8, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_input_element_set_value" webkit_dom_html_input_element_set_value :: 
    Ptr DOMHTMLInputElement ->              -- _obj : TInterface "WebKit2WebExtension" "DOMHTMLInputElement"
    CString ->                              -- value : TBasicType TUTF8
    IO ()


dOMHTMLInputElementSetValue ::
    (MonadIO m, DOMHTMLInputElementK a) =>
    a ->                                    -- _obj
    T.Text ->                               -- value
    m ()
dOMHTMLInputElementSetValue _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    value' <- textToCString value
    webkit_dom_html_input_element_set_value _obj' value'
    touchManagedPtr _obj
    freeMem value'
    return ()

-- method DOMHTMLInputElement::set_width
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLInputElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "value", argType = TBasicType TUInt64, direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_input_element_set_width" webkit_dom_html_input_element_set_width :: 
    Ptr DOMHTMLInputElement ->              -- _obj : TInterface "WebKit2WebExtension" "DOMHTMLInputElement"
    Word64 ->                               -- value : TBasicType TUInt64
    IO ()


dOMHTMLInputElementSetWidth ::
    (MonadIO m, DOMHTMLInputElementK a) =>
    a ->                                    -- _obj
    Word64 ->                               -- value
    m ()
dOMHTMLInputElementSetWidth _obj value = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    webkit_dom_html_input_element_set_width _obj' value
    touchManagedPtr _obj
    return ()


