
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit2WebExtension.Objects.DOMHTMLMarqueeElement
    ( 

-- * Exported types
    DOMHTMLMarqueeElement(..)               ,
    DOMHTMLMarqueeElementK                  ,
    toDOMHTMLMarqueeElement                 ,
    noDOMHTMLMarqueeElement                 ,


 -- * Methods
-- ** dOMHTMLMarqueeElementStart
    dOMHTMLMarqueeElementStart              ,


-- ** dOMHTMLMarqueeElementStop
    dOMHTMLMarqueeElementStop               ,




 -- * Properties
-- ** Behavior
    DOMHTMLMarqueeElementBehaviorPropertyInfo,
    constructDOMHTMLMarqueeElementBehavior  ,
    getDOMHTMLMarqueeElementBehavior        ,
    setDOMHTMLMarqueeElementBehavior        ,


-- ** BgColor
    DOMHTMLMarqueeElementBgColorPropertyInfo,
    constructDOMHTMLMarqueeElementBgColor   ,
    getDOMHTMLMarqueeElementBgColor         ,
    setDOMHTMLMarqueeElementBgColor         ,


-- ** Direction
    DOMHTMLMarqueeElementDirectionPropertyInfo,
    constructDOMHTMLMarqueeElementDirection ,
    getDOMHTMLMarqueeElementDirection       ,
    setDOMHTMLMarqueeElementDirection       ,


-- ** Height
    DOMHTMLMarqueeElementHeightPropertyInfo ,
    constructDOMHTMLMarqueeElementHeight    ,
    getDOMHTMLMarqueeElementHeight          ,
    setDOMHTMLMarqueeElementHeight          ,


-- ** Hspace
    DOMHTMLMarqueeElementHspacePropertyInfo ,
    constructDOMHTMLMarqueeElementHspace    ,
    getDOMHTMLMarqueeElementHspace          ,
    setDOMHTMLMarqueeElementHspace          ,


-- ** Loop
    DOMHTMLMarqueeElementLoopPropertyInfo   ,
    constructDOMHTMLMarqueeElementLoop      ,
    getDOMHTMLMarqueeElementLoop            ,
    setDOMHTMLMarqueeElementLoop            ,


-- ** ScrollAmount
    DOMHTMLMarqueeElementScrollAmountPropertyInfo,
    constructDOMHTMLMarqueeElementScrollAmount,
    getDOMHTMLMarqueeElementScrollAmount    ,
    setDOMHTMLMarqueeElementScrollAmount    ,


-- ** ScrollDelay
    DOMHTMLMarqueeElementScrollDelayPropertyInfo,
    constructDOMHTMLMarqueeElementScrollDelay,
    getDOMHTMLMarqueeElementScrollDelay     ,
    setDOMHTMLMarqueeElementScrollDelay     ,


-- ** TrueSpeed
    DOMHTMLMarqueeElementTrueSpeedPropertyInfo,
    constructDOMHTMLMarqueeElementTrueSpeed ,
    getDOMHTMLMarqueeElementTrueSpeed       ,
    setDOMHTMLMarqueeElementTrueSpeed       ,


-- ** Vspace
    DOMHTMLMarqueeElementVspacePropertyInfo ,
    constructDOMHTMLMarqueeElementVspace    ,
    getDOMHTMLMarqueeElementVspace          ,
    setDOMHTMLMarqueeElementVspace          ,


-- ** Width
    DOMHTMLMarqueeElementWidthPropertyInfo  ,
    constructDOMHTMLMarqueeElementWidth     ,
    getDOMHTMLMarqueeElementWidth           ,
    setDOMHTMLMarqueeElementWidth           ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit2WebExtension.Types
import GI.WebKit2WebExtension.Callbacks
import qualified GI.GObject as GObject

newtype DOMHTMLMarqueeElement = DOMHTMLMarqueeElement (ForeignPtr DOMHTMLMarqueeElement)
foreign import ccall "webkit_dom_html_marquee_element_get_type"
    c_webkit_dom_html_marquee_element_get_type :: IO GType

type instance ParentTypes DOMHTMLMarqueeElement = DOMHTMLMarqueeElementParentTypes
type DOMHTMLMarqueeElementParentTypes = '[DOMHTMLElement, DOMElement, DOMNode, DOMObject, GObject.Object, DOMEventTarget]

instance GObject DOMHTMLMarqueeElement where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_dom_html_marquee_element_get_type
    

class GObject o => DOMHTMLMarqueeElementK o
instance (GObject o, IsDescendantOf DOMHTMLMarqueeElement o) => DOMHTMLMarqueeElementK o

toDOMHTMLMarqueeElement :: DOMHTMLMarqueeElementK o => o -> IO DOMHTMLMarqueeElement
toDOMHTMLMarqueeElement = unsafeCastTo DOMHTMLMarqueeElement

noDOMHTMLMarqueeElement :: Maybe DOMHTMLMarqueeElement
noDOMHTMLMarqueeElement = Nothing

-- VVV Prop "behavior"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLMarqueeElementBehavior :: (MonadIO m, DOMHTMLMarqueeElementK o) => o -> m T.Text
getDOMHTMLMarqueeElementBehavior obj = liftIO $ getObjectPropertyString obj "behavior"

setDOMHTMLMarqueeElementBehavior :: (MonadIO m, DOMHTMLMarqueeElementK o) => o -> T.Text -> m ()
setDOMHTMLMarqueeElementBehavior obj val = liftIO $ setObjectPropertyString obj "behavior" val

constructDOMHTMLMarqueeElementBehavior :: T.Text -> IO ([Char], GValue)
constructDOMHTMLMarqueeElementBehavior val = constructObjectPropertyString "behavior" val

data DOMHTMLMarqueeElementBehaviorPropertyInfo
instance AttrInfo DOMHTMLMarqueeElementBehaviorPropertyInfo where
    type AttrAllowedOps DOMHTMLMarqueeElementBehaviorPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLMarqueeElementBehaviorPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLMarqueeElementBehaviorPropertyInfo = DOMHTMLMarqueeElementK
    type AttrGetType DOMHTMLMarqueeElementBehaviorPropertyInfo = T.Text
    type AttrLabel DOMHTMLMarqueeElementBehaviorPropertyInfo = "DOMHTMLMarqueeElement::behavior"
    attrGet _ = getDOMHTMLMarqueeElementBehavior
    attrSet _ = setDOMHTMLMarqueeElementBehavior
    attrConstruct _ = constructDOMHTMLMarqueeElementBehavior

-- VVV Prop "bg-color"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLMarqueeElementBgColor :: (MonadIO m, DOMHTMLMarqueeElementK o) => o -> m T.Text
getDOMHTMLMarqueeElementBgColor obj = liftIO $ getObjectPropertyString obj "bg-color"

setDOMHTMLMarqueeElementBgColor :: (MonadIO m, DOMHTMLMarqueeElementK o) => o -> T.Text -> m ()
setDOMHTMLMarqueeElementBgColor obj val = liftIO $ setObjectPropertyString obj "bg-color" val

constructDOMHTMLMarqueeElementBgColor :: T.Text -> IO ([Char], GValue)
constructDOMHTMLMarqueeElementBgColor val = constructObjectPropertyString "bg-color" val

data DOMHTMLMarqueeElementBgColorPropertyInfo
instance AttrInfo DOMHTMLMarqueeElementBgColorPropertyInfo where
    type AttrAllowedOps DOMHTMLMarqueeElementBgColorPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLMarqueeElementBgColorPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLMarqueeElementBgColorPropertyInfo = DOMHTMLMarqueeElementK
    type AttrGetType DOMHTMLMarqueeElementBgColorPropertyInfo = T.Text
    type AttrLabel DOMHTMLMarqueeElementBgColorPropertyInfo = "DOMHTMLMarqueeElement::bg-color"
    attrGet _ = getDOMHTMLMarqueeElementBgColor
    attrSet _ = setDOMHTMLMarqueeElementBgColor
    attrConstruct _ = constructDOMHTMLMarqueeElementBgColor

-- VVV Prop "direction"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLMarqueeElementDirection :: (MonadIO m, DOMHTMLMarqueeElementK o) => o -> m T.Text
getDOMHTMLMarqueeElementDirection obj = liftIO $ getObjectPropertyString obj "direction"

setDOMHTMLMarqueeElementDirection :: (MonadIO m, DOMHTMLMarqueeElementK o) => o -> T.Text -> m ()
setDOMHTMLMarqueeElementDirection obj val = liftIO $ setObjectPropertyString obj "direction" val

constructDOMHTMLMarqueeElementDirection :: T.Text -> IO ([Char], GValue)
constructDOMHTMLMarqueeElementDirection val = constructObjectPropertyString "direction" val

data DOMHTMLMarqueeElementDirectionPropertyInfo
instance AttrInfo DOMHTMLMarqueeElementDirectionPropertyInfo where
    type AttrAllowedOps DOMHTMLMarqueeElementDirectionPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLMarqueeElementDirectionPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLMarqueeElementDirectionPropertyInfo = DOMHTMLMarqueeElementK
    type AttrGetType DOMHTMLMarqueeElementDirectionPropertyInfo = T.Text
    type AttrLabel DOMHTMLMarqueeElementDirectionPropertyInfo = "DOMHTMLMarqueeElement::direction"
    attrGet _ = getDOMHTMLMarqueeElementDirection
    attrSet _ = setDOMHTMLMarqueeElementDirection
    attrConstruct _ = constructDOMHTMLMarqueeElementDirection

-- VVV Prop "height"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLMarqueeElementHeight :: (MonadIO m, DOMHTMLMarqueeElementK o) => o -> m T.Text
getDOMHTMLMarqueeElementHeight obj = liftIO $ getObjectPropertyString obj "height"

setDOMHTMLMarqueeElementHeight :: (MonadIO m, DOMHTMLMarqueeElementK o) => o -> T.Text -> m ()
setDOMHTMLMarqueeElementHeight obj val = liftIO $ setObjectPropertyString obj "height" val

constructDOMHTMLMarqueeElementHeight :: T.Text -> IO ([Char], GValue)
constructDOMHTMLMarqueeElementHeight val = constructObjectPropertyString "height" val

data DOMHTMLMarqueeElementHeightPropertyInfo
instance AttrInfo DOMHTMLMarqueeElementHeightPropertyInfo where
    type AttrAllowedOps DOMHTMLMarqueeElementHeightPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLMarqueeElementHeightPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLMarqueeElementHeightPropertyInfo = DOMHTMLMarqueeElementK
    type AttrGetType DOMHTMLMarqueeElementHeightPropertyInfo = T.Text
    type AttrLabel DOMHTMLMarqueeElementHeightPropertyInfo = "DOMHTMLMarqueeElement::height"
    attrGet _ = getDOMHTMLMarqueeElementHeight
    attrSet _ = setDOMHTMLMarqueeElementHeight
    attrConstruct _ = constructDOMHTMLMarqueeElementHeight

-- VVV Prop "hspace"
   -- Type: TBasicType TUInt64
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLMarqueeElementHspace :: (MonadIO m, DOMHTMLMarqueeElementK o) => o -> m Word64
getDOMHTMLMarqueeElementHspace obj = liftIO $ getObjectPropertyUInt64 obj "hspace"

setDOMHTMLMarqueeElementHspace :: (MonadIO m, DOMHTMLMarqueeElementK o) => o -> Word64 -> m ()
setDOMHTMLMarqueeElementHspace obj val = liftIO $ setObjectPropertyUInt64 obj "hspace" val

constructDOMHTMLMarqueeElementHspace :: Word64 -> IO ([Char], GValue)
constructDOMHTMLMarqueeElementHspace val = constructObjectPropertyUInt64 "hspace" val

data DOMHTMLMarqueeElementHspacePropertyInfo
instance AttrInfo DOMHTMLMarqueeElementHspacePropertyInfo where
    type AttrAllowedOps DOMHTMLMarqueeElementHspacePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLMarqueeElementHspacePropertyInfo = (~) Word64
    type AttrBaseTypeConstraint DOMHTMLMarqueeElementHspacePropertyInfo = DOMHTMLMarqueeElementK
    type AttrGetType DOMHTMLMarqueeElementHspacePropertyInfo = Word64
    type AttrLabel DOMHTMLMarqueeElementHspacePropertyInfo = "DOMHTMLMarqueeElement::hspace"
    attrGet _ = getDOMHTMLMarqueeElementHspace
    attrSet _ = setDOMHTMLMarqueeElementHspace
    attrConstruct _ = constructDOMHTMLMarqueeElementHspace

-- VVV Prop "loop"
   -- Type: TBasicType TInt64
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLMarqueeElementLoop :: (MonadIO m, DOMHTMLMarqueeElementK o) => o -> m Int64
getDOMHTMLMarqueeElementLoop obj = liftIO $ getObjectPropertyInt64 obj "loop"

setDOMHTMLMarqueeElementLoop :: (MonadIO m, DOMHTMLMarqueeElementK o) => o -> Int64 -> m ()
setDOMHTMLMarqueeElementLoop obj val = liftIO $ setObjectPropertyInt64 obj "loop" val

constructDOMHTMLMarqueeElementLoop :: Int64 -> IO ([Char], GValue)
constructDOMHTMLMarqueeElementLoop val = constructObjectPropertyInt64 "loop" val

data DOMHTMLMarqueeElementLoopPropertyInfo
instance AttrInfo DOMHTMLMarqueeElementLoopPropertyInfo where
    type AttrAllowedOps DOMHTMLMarqueeElementLoopPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLMarqueeElementLoopPropertyInfo = (~) Int64
    type AttrBaseTypeConstraint DOMHTMLMarqueeElementLoopPropertyInfo = DOMHTMLMarqueeElementK
    type AttrGetType DOMHTMLMarqueeElementLoopPropertyInfo = Int64
    type AttrLabel DOMHTMLMarqueeElementLoopPropertyInfo = "DOMHTMLMarqueeElement::loop"
    attrGet _ = getDOMHTMLMarqueeElementLoop
    attrSet _ = setDOMHTMLMarqueeElementLoop
    attrConstruct _ = constructDOMHTMLMarqueeElementLoop

-- VVV Prop "scroll-amount"
   -- Type: TBasicType TInt64
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLMarqueeElementScrollAmount :: (MonadIO m, DOMHTMLMarqueeElementK o) => o -> m Int64
getDOMHTMLMarqueeElementScrollAmount obj = liftIO $ getObjectPropertyInt64 obj "scroll-amount"

setDOMHTMLMarqueeElementScrollAmount :: (MonadIO m, DOMHTMLMarqueeElementK o) => o -> Int64 -> m ()
setDOMHTMLMarqueeElementScrollAmount obj val = liftIO $ setObjectPropertyInt64 obj "scroll-amount" val

constructDOMHTMLMarqueeElementScrollAmount :: Int64 -> IO ([Char], GValue)
constructDOMHTMLMarqueeElementScrollAmount val = constructObjectPropertyInt64 "scroll-amount" val

data DOMHTMLMarqueeElementScrollAmountPropertyInfo
instance AttrInfo DOMHTMLMarqueeElementScrollAmountPropertyInfo where
    type AttrAllowedOps DOMHTMLMarqueeElementScrollAmountPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLMarqueeElementScrollAmountPropertyInfo = (~) Int64
    type AttrBaseTypeConstraint DOMHTMLMarqueeElementScrollAmountPropertyInfo = DOMHTMLMarqueeElementK
    type AttrGetType DOMHTMLMarqueeElementScrollAmountPropertyInfo = Int64
    type AttrLabel DOMHTMLMarqueeElementScrollAmountPropertyInfo = "DOMHTMLMarqueeElement::scroll-amount"
    attrGet _ = getDOMHTMLMarqueeElementScrollAmount
    attrSet _ = setDOMHTMLMarqueeElementScrollAmount
    attrConstruct _ = constructDOMHTMLMarqueeElementScrollAmount

-- VVV Prop "scroll-delay"
   -- Type: TBasicType TInt64
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLMarqueeElementScrollDelay :: (MonadIO m, DOMHTMLMarqueeElementK o) => o -> m Int64
getDOMHTMLMarqueeElementScrollDelay obj = liftIO $ getObjectPropertyInt64 obj "scroll-delay"

setDOMHTMLMarqueeElementScrollDelay :: (MonadIO m, DOMHTMLMarqueeElementK o) => o -> Int64 -> m ()
setDOMHTMLMarqueeElementScrollDelay obj val = liftIO $ setObjectPropertyInt64 obj "scroll-delay" val

constructDOMHTMLMarqueeElementScrollDelay :: Int64 -> IO ([Char], GValue)
constructDOMHTMLMarqueeElementScrollDelay val = constructObjectPropertyInt64 "scroll-delay" val

data DOMHTMLMarqueeElementScrollDelayPropertyInfo
instance AttrInfo DOMHTMLMarqueeElementScrollDelayPropertyInfo where
    type AttrAllowedOps DOMHTMLMarqueeElementScrollDelayPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLMarqueeElementScrollDelayPropertyInfo = (~) Int64
    type AttrBaseTypeConstraint DOMHTMLMarqueeElementScrollDelayPropertyInfo = DOMHTMLMarqueeElementK
    type AttrGetType DOMHTMLMarqueeElementScrollDelayPropertyInfo = Int64
    type AttrLabel DOMHTMLMarqueeElementScrollDelayPropertyInfo = "DOMHTMLMarqueeElement::scroll-delay"
    attrGet _ = getDOMHTMLMarqueeElementScrollDelay
    attrSet _ = setDOMHTMLMarqueeElementScrollDelay
    attrConstruct _ = constructDOMHTMLMarqueeElementScrollDelay

-- VVV Prop "true-speed"
   -- Type: TBasicType TBoolean
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLMarqueeElementTrueSpeed :: (MonadIO m, DOMHTMLMarqueeElementK o) => o -> m Bool
getDOMHTMLMarqueeElementTrueSpeed obj = liftIO $ getObjectPropertyBool obj "true-speed"

setDOMHTMLMarqueeElementTrueSpeed :: (MonadIO m, DOMHTMLMarqueeElementK o) => o -> Bool -> m ()
setDOMHTMLMarqueeElementTrueSpeed obj val = liftIO $ setObjectPropertyBool obj "true-speed" val

constructDOMHTMLMarqueeElementTrueSpeed :: Bool -> IO ([Char], GValue)
constructDOMHTMLMarqueeElementTrueSpeed val = constructObjectPropertyBool "true-speed" val

data DOMHTMLMarqueeElementTrueSpeedPropertyInfo
instance AttrInfo DOMHTMLMarqueeElementTrueSpeedPropertyInfo where
    type AttrAllowedOps DOMHTMLMarqueeElementTrueSpeedPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLMarqueeElementTrueSpeedPropertyInfo = (~) Bool
    type AttrBaseTypeConstraint DOMHTMLMarqueeElementTrueSpeedPropertyInfo = DOMHTMLMarqueeElementK
    type AttrGetType DOMHTMLMarqueeElementTrueSpeedPropertyInfo = Bool
    type AttrLabel DOMHTMLMarqueeElementTrueSpeedPropertyInfo = "DOMHTMLMarqueeElement::true-speed"
    attrGet _ = getDOMHTMLMarqueeElementTrueSpeed
    attrSet _ = setDOMHTMLMarqueeElementTrueSpeed
    attrConstruct _ = constructDOMHTMLMarqueeElementTrueSpeed

-- VVV Prop "vspace"
   -- Type: TBasicType TUInt64
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLMarqueeElementVspace :: (MonadIO m, DOMHTMLMarqueeElementK o) => o -> m Word64
getDOMHTMLMarqueeElementVspace obj = liftIO $ getObjectPropertyUInt64 obj "vspace"

setDOMHTMLMarqueeElementVspace :: (MonadIO m, DOMHTMLMarqueeElementK o) => o -> Word64 -> m ()
setDOMHTMLMarqueeElementVspace obj val = liftIO $ setObjectPropertyUInt64 obj "vspace" val

constructDOMHTMLMarqueeElementVspace :: Word64 -> IO ([Char], GValue)
constructDOMHTMLMarqueeElementVspace val = constructObjectPropertyUInt64 "vspace" val

data DOMHTMLMarqueeElementVspacePropertyInfo
instance AttrInfo DOMHTMLMarqueeElementVspacePropertyInfo where
    type AttrAllowedOps DOMHTMLMarqueeElementVspacePropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLMarqueeElementVspacePropertyInfo = (~) Word64
    type AttrBaseTypeConstraint DOMHTMLMarqueeElementVspacePropertyInfo = DOMHTMLMarqueeElementK
    type AttrGetType DOMHTMLMarqueeElementVspacePropertyInfo = Word64
    type AttrLabel DOMHTMLMarqueeElementVspacePropertyInfo = "DOMHTMLMarqueeElement::vspace"
    attrGet _ = getDOMHTMLMarqueeElementVspace
    attrSet _ = setDOMHTMLMarqueeElementVspace
    attrConstruct _ = constructDOMHTMLMarqueeElementVspace

-- VVV Prop "width"
   -- Type: TBasicType TUTF8
   -- Flags: [PropertyReadable,PropertyWritable]

getDOMHTMLMarqueeElementWidth :: (MonadIO m, DOMHTMLMarqueeElementK o) => o -> m T.Text
getDOMHTMLMarqueeElementWidth obj = liftIO $ getObjectPropertyString obj "width"

setDOMHTMLMarqueeElementWidth :: (MonadIO m, DOMHTMLMarqueeElementK o) => o -> T.Text -> m ()
setDOMHTMLMarqueeElementWidth obj val = liftIO $ setObjectPropertyString obj "width" val

constructDOMHTMLMarqueeElementWidth :: T.Text -> IO ([Char], GValue)
constructDOMHTMLMarqueeElementWidth val = constructObjectPropertyString "width" val

data DOMHTMLMarqueeElementWidthPropertyInfo
instance AttrInfo DOMHTMLMarqueeElementWidthPropertyInfo where
    type AttrAllowedOps DOMHTMLMarqueeElementWidthPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint DOMHTMLMarqueeElementWidthPropertyInfo = (~) T.Text
    type AttrBaseTypeConstraint DOMHTMLMarqueeElementWidthPropertyInfo = DOMHTMLMarqueeElementK
    type AttrGetType DOMHTMLMarqueeElementWidthPropertyInfo = T.Text
    type AttrLabel DOMHTMLMarqueeElementWidthPropertyInfo = "DOMHTMLMarqueeElement::width"
    attrGet _ = getDOMHTMLMarqueeElementWidth
    attrSet _ = setDOMHTMLMarqueeElementWidth
    attrConstruct _ = constructDOMHTMLMarqueeElementWidth

type instance AttributeList DOMHTMLMarqueeElement = DOMHTMLMarqueeElementAttributeList
type DOMHTMLMarqueeElementAttributeList = ('[ '("access-key", DOMHTMLElementAccessKeyPropertyInfo), '("attributes", DOMElementAttributesPropertyInfo), '("base-uri", DOMNodeBaseUriPropertyInfo), '("behavior", DOMHTMLMarqueeElementBehaviorPropertyInfo), '("bg-color", DOMHTMLMarqueeElementBgColorPropertyInfo), '("child-element-count", DOMElementChildElementCountPropertyInfo), '("child-nodes", DOMNodeChildNodesPropertyInfo), '("children", DOMHTMLElementChildrenPropertyInfo), '("class-name", DOMElementClassNamePropertyInfo), '("client-height", DOMElementClientHeightPropertyInfo), '("client-left", DOMElementClientLeftPropertyInfo), '("client-top", DOMElementClientTopPropertyInfo), '("client-width", DOMElementClientWidthPropertyInfo), '("content-editable", DOMHTMLElementContentEditablePropertyInfo), '("core-object", DOMObjectCoreObjectPropertyInfo), '("dir", DOMHTMLElementDirPropertyInfo), '("direction", DOMHTMLMarqueeElementDirectionPropertyInfo), '("draggable", DOMHTMLElementDraggablePropertyInfo), '("first-child", DOMNodeFirstChildPropertyInfo), '("first-element-child", DOMElementFirstElementChildPropertyInfo), '("height", DOMHTMLMarqueeElementHeightPropertyInfo), '("hidden", DOMHTMLElementHiddenPropertyInfo), '("hspace", DOMHTMLMarqueeElementHspacePropertyInfo), '("id", DOMElementIdPropertyInfo), '("inner-html", DOMElementInnerHtmlPropertyInfo), '("inner-text", DOMHTMLElementInnerTextPropertyInfo), '("is-content-editable", DOMHTMLElementIsContentEditablePropertyInfo), '("lang", DOMHTMLElementLangPropertyInfo), '("last-child", DOMNodeLastChildPropertyInfo), '("last-element-child", DOMElementLastElementChildPropertyInfo), '("local-name", DOMNodeLocalNamePropertyInfo), '("loop", DOMHTMLMarqueeElementLoopPropertyInfo), '("namespace-uri", DOMNodeNamespaceUriPropertyInfo), '("next-element-sibling", DOMElementNextElementSiblingPropertyInfo), '("next-sibling", DOMNodeNextSiblingPropertyInfo), '("node-name", DOMNodeNodeNamePropertyInfo), '("node-type", DOMNodeNodeTypePropertyInfo), '("node-value", DOMNodeNodeValuePropertyInfo), '("offset-height", DOMElementOffsetHeightPropertyInfo), '("offset-left", DOMElementOffsetLeftPropertyInfo), '("offset-parent", DOMElementOffsetParentPropertyInfo), '("offset-top", DOMElementOffsetTopPropertyInfo), '("offset-width", DOMElementOffsetWidthPropertyInfo), '("outer-html", DOMElementOuterHtmlPropertyInfo), '("outer-text", DOMHTMLElementOuterTextPropertyInfo), '("owner-document", DOMNodeOwnerDocumentPropertyInfo), '("parent-element", DOMNodeParentElementPropertyInfo), '("parent-node", DOMNodeParentNodePropertyInfo), '("prefix", DOMNodePrefixPropertyInfo), '("previous-element-sibling", DOMElementPreviousElementSiblingPropertyInfo), '("previous-sibling", DOMNodePreviousSiblingPropertyInfo), '("scroll-amount", DOMHTMLMarqueeElementScrollAmountPropertyInfo), '("scroll-delay", DOMHTMLMarqueeElementScrollDelayPropertyInfo), '("scroll-height", DOMElementScrollHeightPropertyInfo), '("scroll-left", DOMElementScrollLeftPropertyInfo), '("scroll-top", DOMElementScrollTopPropertyInfo), '("scroll-width", DOMElementScrollWidthPropertyInfo), '("spellcheck", DOMHTMLElementSpellcheckPropertyInfo), '("style", DOMElementStylePropertyInfo), '("tab-index", DOMHTMLElementTabIndexPropertyInfo), '("tag-name", DOMElementTagNamePropertyInfo), '("text-content", DOMNodeTextContentPropertyInfo), '("title", DOMHTMLElementTitlePropertyInfo), '("translate", DOMHTMLElementTranslatePropertyInfo), '("true-speed", DOMHTMLMarqueeElementTrueSpeedPropertyInfo), '("vspace", DOMHTMLMarqueeElementVspacePropertyInfo), '("webkit-region-overset", DOMElementWebkitRegionOversetPropertyInfo), '("webkitdropzone", DOMHTMLElementWebkitdropzonePropertyInfo), '("width", DOMHTMLMarqueeElementWidthPropertyInfo)] :: [(Symbol, *)])

type instance SignalList DOMHTMLMarqueeElement = DOMHTMLMarqueeElementSignalList
type DOMHTMLMarqueeElementSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method DOMHTMLMarqueeElement::start
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLMarqueeElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLMarqueeElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_marquee_element_start" webkit_dom_html_marquee_element_start :: 
    Ptr DOMHTMLMarqueeElement ->            -- _obj : TInterface "WebKit2WebExtension" "DOMHTMLMarqueeElement"
    IO ()


dOMHTMLMarqueeElementStart ::
    (MonadIO m, DOMHTMLMarqueeElementK a) =>
    a ->                                    -- _obj
    m ()
dOMHTMLMarqueeElementStart _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    webkit_dom_html_marquee_element_start _obj'
    touchManagedPtr _obj
    return ()

-- method DOMHTMLMarqueeElement::stop
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLMarqueeElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "DOMHTMLMarqueeElement", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "webkit_dom_html_marquee_element_stop" webkit_dom_html_marquee_element_stop :: 
    Ptr DOMHTMLMarqueeElement ->            -- _obj : TInterface "WebKit2WebExtension" "DOMHTMLMarqueeElement"
    IO ()


dOMHTMLMarqueeElementStop ::
    (MonadIO m, DOMHTMLMarqueeElementK a) =>
    a ->                                    -- _obj
    m ()
dOMHTMLMarqueeElementStop _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    webkit_dom_html_marquee_element_stop _obj'
    touchManagedPtr _obj
    return ()


