
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit2WebExtension.Objects.WebHitTestResult
    ( 

-- * Exported types
    WebHitTestResult(..)                    ,
    WebHitTestResultK                       ,
    toWebHitTestResult                      ,
    noWebHitTestResult                      ,


 -- * Methods
-- ** webHitTestResultGetNode
    webHitTestResultGetNode                 ,




 -- * Properties
-- ** Node
    WebHitTestResultNodePropertyInfo        ,
    constructWebHitTestResultNode           ,
    getWebHitTestResultNode                 ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit2WebExtension.Types
import GI.WebKit2WebExtension.Callbacks
import qualified GI.GObject as GObject

newtype WebHitTestResult = WebHitTestResult (ForeignPtr WebHitTestResult)
foreign import ccall "webkit_web_hit_test_result_get_type"
    c_webkit_web_hit_test_result_get_type :: IO GType

type instance ParentTypes WebHitTestResult = WebHitTestResultParentTypes
type WebHitTestResultParentTypes = '[HitTestResult, GObject.Object]

instance GObject WebHitTestResult where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_webkit_web_hit_test_result_get_type
    

class GObject o => WebHitTestResultK o
instance (GObject o, IsDescendantOf WebHitTestResult o) => WebHitTestResultK o

toWebHitTestResult :: WebHitTestResultK o => o -> IO WebHitTestResult
toWebHitTestResult = unsafeCastTo WebHitTestResult

noWebHitTestResult :: Maybe WebHitTestResult
noWebHitTestResult = Nothing

-- VVV Prop "node"
   -- Type: TInterface "WebKit2WebExtension" "DOMNode"
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstructOnly]

getWebHitTestResultNode :: (MonadIO m, WebHitTestResultK o) => o -> m DOMNode
getWebHitTestResultNode obj = liftIO $ getObjectPropertyObject obj "node" DOMNode

constructWebHitTestResultNode :: (DOMNodeK a) => a -> IO ([Char], GValue)
constructWebHitTestResultNode val = constructObjectPropertyObject "node" val

data WebHitTestResultNodePropertyInfo
instance AttrInfo WebHitTestResultNodePropertyInfo where
    type AttrAllowedOps WebHitTestResultNodePropertyInfo = '[ 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint WebHitTestResultNodePropertyInfo = DOMNodeK
    type AttrBaseTypeConstraint WebHitTestResultNodePropertyInfo = WebHitTestResultK
    type AttrGetType WebHitTestResultNodePropertyInfo = DOMNode
    type AttrLabel WebHitTestResultNodePropertyInfo = "WebHitTestResult::node"
    attrGet _ = getWebHitTestResultNode
    attrSet _ = undefined
    attrConstruct _ = constructWebHitTestResultNode

type instance AttributeList WebHitTestResult = WebHitTestResultAttributeList
type WebHitTestResultAttributeList = ('[ '("context", HitTestResultContextPropertyInfo), '("image-uri", HitTestResultImageUriPropertyInfo), '("link-label", HitTestResultLinkLabelPropertyInfo), '("link-title", HitTestResultLinkTitlePropertyInfo), '("link-uri", HitTestResultLinkUriPropertyInfo), '("media-uri", HitTestResultMediaUriPropertyInfo), '("node", WebHitTestResultNodePropertyInfo)] :: [(Symbol, *)])

type instance SignalList WebHitTestResult = WebHitTestResultSignalList
type WebHitTestResultSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method WebHitTestResult::get_node
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "WebHitTestResult", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "WebKit2WebExtension" "WebHitTestResult", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TInterface "WebKit2WebExtension" "DOMNode"
-- throws : False
-- Skip return : False

foreign import ccall "webkit_web_hit_test_result_get_node" webkit_web_hit_test_result_get_node :: 
    Ptr WebHitTestResult ->                 -- _obj : TInterface "WebKit2WebExtension" "WebHitTestResult"
    IO (Ptr DOMNode)


webHitTestResultGetNode ::
    (MonadIO m, WebHitTestResultK a) =>
    a ->                                    -- _obj
    m DOMNode
webHitTestResultGetNode _obj = liftIO $ do
    let _obj' = unsafeManagedPtrCastPtr _obj
    result <- webkit_web_hit_test_result_get_node _obj'
    checkUnexpectedReturnNULL "webkit_web_hit_test_result_get_node" result
    result' <- (newObject DOMNode) result
    touchManagedPtr _obj
    return result'


